﻿Imports System.Globalization

Public Class cls_value_to_color
    Implements IMultiValueConverter

    ''' <summary>
    ''' Converts a given value of type decimal and gives back a color depending on the settings:
    ''' e.g.
    ''' </summary>
    ''' <param name="values">Value to check and then positive negative and neutral color</param>
    ''' <param name="targetType"></param>
    ''' <param name="parameter">if + then returns positive color if value greather than 0 if - returns positive color if value lesser than 0 </param>
    ''' <param name="culture"></param>
    ''' <returns></returns>
    Public Function Convert(values() As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IMultiValueConverter.Convert
        If values Is Nothing OrElse parameter Is Nothing Then Return Nothing

        Dim v_value As Decimal = CDec(values(0))
        Dim v_pos_color As SolidColorBrush = CType(values(1), SolidColorBrush)
        Dim v_neg_color As SolidColorBrush = CType(values(2), SolidColorBrush)
        Dim v_neutral_color As SolidColorBrush = ColorBrushFromResources("IdealForegroundColorBrush")

        If parameter.ToString = "+" Then
            'Return pos value if value > 0
            Select Case True
                Case v_value > 0
                    Return v_pos_color
                Case v_value < 0
                    Return v_neg_color
                Case Else
                    Return v_neutral_color
            End Select
        Else
            'Return pos value if value < 0
            Select Case True
                Case v_value < 0
                    Return v_pos_color
                Case v_value > 0
                    Return v_neg_color
                Case Else
                    Return v_neutral_color
            End Select
        End If
    End Function

    Public Function ConvertBack(value As Object, targetTypes() As Type, parameter As Object, culture As CultureInfo) As Object() Implements IMultiValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
