﻿
Imports System.Globalization
Imports System.Reflection

Public Class CodeToDescriptionConverter
    Implements IMultiValueConverter
    Public Property CodeAttribute() As String
        Get
            Return m_CodeAttribute
        End Get
        Set
            m_CodeAttribute = Value
        End Set
    End Property
    Private m_CodeAttribute As String
    Public Property StringFormat() As String
        Get
            Return m_StringFormat
        End Get
        Set
            m_StringFormat = Value
        End Set
    End Property
    Private m_StringFormat As String
    Public Property DescriptionAttributes() As List(Of String)
        Get
            Return m_DescriptionAttributes
        End Get
        Set
            m_DescriptionAttributes = Value
        End Set
    End Property
    Private m_DescriptionAttributes As List(Of String)

    Dim v_returnparent As Boolean = False
    Public Property ReturnParent As Boolean
        Get
            Return v_returnparent
        End Get
        Set(value As Boolean)
            v_returnparent = value
        End Set
    End Property


    Public Sub New()
        StringFormat = "{0}"
        DescriptionAttributes = New List(Of String)()
    End Sub

    Public Function Convert(values As Object(), targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IMultiValueConverter.Convert
        If values(0) Is Nothing OrElse values.Length <> 2 OrElse values(0).ToString = "0" OrElse values(0) Is DependencyProperty.UnsetValue OrElse values(1) Is DependencyProperty.UnsetValue OrElse values(0) Is Nothing OrElse values(1) Is Nothing Then
            Return Nothing
        End If
        'https://stackoverflow.com/questions/10909801/wpf-datagrid-celleditingtemplate-combobox-multiple-data-to-celltemplate-textbox
        Dim code As String = values(0).ToString()
        Dim sourceCollection As ListCollectionView = TryCast(values(values.Length - 1), ListCollectionView)
        Dim returnDescriptions As Object() = New Object(DescriptionAttributes.Count - 1) {}
        For Each obj As Object In sourceCollection
            Dim codePropertyInfo As PropertyInfo = obj.[GetType]().GetProperty(CodeAttribute)
            If codePropertyInfo Is Nothing Then
                Throw New ArgumentException(("Code Property " & CodeAttribute) + " not found")
            End If
            Dim codeValue As String = codePropertyInfo.GetValue(obj, Nothing).ToString()
            If code = codeValue Then
                For i As Integer = 0 To DescriptionAttributes.Count - 1
                    Dim descriptionAttribute As String = DescriptionAttributes(i)
                    Dim descriptionPropertyInfo As PropertyInfo = obj.[GetType]().GetProperty(descriptionAttribute)
                    If descriptionPropertyInfo Is Nothing Then
                        Throw New ArgumentException(("Description Property " & descriptionAttribute) + " not found")
                    End If
                    Dim descriptionObject As Object = descriptionPropertyInfo.GetValue(obj, Nothing)
                    Dim description As String = ""
                    If descriptionObject IsNot Nothing Then
                        description = descriptionPropertyInfo.GetValue(obj, Nothing).ToString()
                    End If
                    returnDescriptions(i) = description
                Next
                Exit For
            End If
        Next

        ' Ex. string.Format("{0} - {1} - {2}", arg1, arg2, arg3);
        Return String.Format(StringFormat, returnDescriptions)
    End Function

    Public Function ConvertBack(value As Object, targetTypes() As Type, parameter As Object, culture As CultureInfo) As Object() Implements IMultiValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class