﻿Imports System.Globalization

''' <summary>
''' Converter for splitting the totamount of a transaction between positive and negative column of datagrid
''' </summary>
Public Class multi_converter_amount_transrep
    Implements IMultiValueConverter

    Public Function Convert(values() As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IMultiValueConverter.Convert
        '0: current transaction
        '1: currently displayed konto (account)
        If values(0) Is Nothing Then Return String.Empty
        If values(1) Is Nothing Then Return String.Empty
        If parameter Is Nothing Then Return String.Empty

        Dim v_transaction As transactions_repeat_v01 = DirectCast(values(0), transactions_repeat_v01)
        Dim v_konto As konto_v01 = DirectCast(values(1), konto_v01)
        Dim v_param As Integer = System.Convert.ToInt16(parameter.ToString)
        'Parameter Definition is similar to transaction multiplier
        'if multiplier matches with the parameter then return a value else return empty
        Select Case v_transaction.transtyp.multiplier
            Case 1
                '+
                If Not v_param = 1 Then Return String.Empty
            Case -1
                '-
                If Not v_param = -1 Then Return String.Empty
            Case Else
                'transfer
                'wenn eine transferbuchung in der konto_id mit dem aktuellen Konto match ist sie minus
                'wenn eine transferbuchung mit der to_konto_id des aktuellen kontos matched ist sie +
                If v_transaction.konto_id = v_konto.kto_id Then
                    If v_param = -1 Then
                        Return String.Format("{0:C2}", v_transaction.neutral_totamount * -1)
                    Else
                        Return String.Empty
                    End If
                Else
                    If v_param = 1 Then
                        Return String.Format("{0:C2}", v_transaction.neutral_totamount)
                    Else
                        Return String.Empty
                    End If

                End If
        End Select
        Return String.Format("{0:C2}", v_transaction.real_totamount)
        Return String.Format("{0:C2}", Math.Abs(v_transaction.real_totamount))


    End Function

    Public Function ConvertBack(value As Object, targetTypes() As Type, parameter As Object, culture As CultureInfo) As Object() Implements IMultiValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
