﻿Imports System.IO
Imports System.Text
Imports System.Windows.Markup

Public Class TextExtension
    Inherits MarkupExtension

    Private ReadOnly fileName As String

    Public Sub New(ByVal fileName As String)
        Me.fileName = fileName
    End Sub

    Public Overrides Function ProvideValue(ByVal serviceProvider As IServiceProvider) As Object
        Dim uri = New Uri("pack://application:,,,/" & fileName)
        Try
            Using stream = Application.GetResourceStream(uri).Stream
                Dim enc As Encoding = Encoding.GetEncoding("Windows-1252")
                Using reader As StreamReader = New StreamReader(stream, enc)
                    Return reader.ReadToEnd()
                End Using
            End Using
        Catch ex As Exception
            cls_logger.v_logger.Error(String.Format("Error in ProvideValue with URI: {0}", uri.AbsolutePath.ToString))
            Return Nothing
        End Try

    End Function
End Class