﻿''' <summary>
''' Class which defines an Helper Entry for the Status Amount Properties of a konto
''' </summary>
Public Class cls_statusamount
    Inherits GalaSoft.MvvmLight.ObservableObject

    Dim v_status_id As Integer
    Dim v_status_bez As String
    Dim v_status_value As Decimal = 0D

    Sub New()

    End Sub

    Sub New(Id As Integer, Bez As String)
        StatusId = Id
        StatusBez = Bez
    End Sub

    Sub New(Id As Integer, Bez As String, Amount As Decimal, StartValue As Decimal)
        StatusId = Id
        StatusBez = Bez
        StatusValue = Amount
        AccountStartValue = StartValue
    End Sub

    Public Property StatusId As Integer
        Get
            Return v_status_id
        End Get
        Set(value As Integer)
            If v_status_id <> value Then
                v_status_id = value
                RaisePropertyChanged("StatusId")
            End If
        End Set
    End Property

    Public Property StatusBez As String
        Get
            Return v_status_bez
        End Get
        Set(value As String)
            If v_status_bez <> value Then
                v_status_bez = value
                RaisePropertyChanged("StatusBez")
            End If
        End Set
    End Property

    Public Property StatusValue As Decimal
        Get
            Return v_status_value
        End Get
        Set(value As Decimal)
            If v_status_value <> value Then
                v_status_value = value
                RaisePropertyChanged("StatusValue")
                RaisePropertyChanged("SpecAccountAmount")
            End If
        End Set
    End Property

    Dim v_accountstartvalue As Decimal = 0
    Public Property AccountStartValue As Decimal
        Get
            Return v_AccountStartValue
        End Get
        Set(value As Decimal)
            If v_AccountStartValue <> value Then
                v_AccountStartValue = value
                RaisePropertyChanged("AccountStartValue")
                RaisePropertyChanged("SpecAccountAmount")
            End If
        End Set
    End Property

    Public ReadOnly Property SpecAccountAmount As Decimal
        Get
            If StatusValue = Nothing OrElse AccountStartValue = Nothing Then
                Return 0
            Else
                Return StatusValue + AccountStartValue
            End If
        End Get
    End Property



End Class
