﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.ComponentModel

''' <summary>
''' Class which represents a Import Column Definition for a bookjournal
''' </summary>
Public Class bookjournal_import_definition_v01
    Inherits model_base

    Dim v_id As Integer
    Dim v_bezeichnung As String

    'CSV:
    'Textqualifier:
    Dim v_csv_textqualifier As String = """"
    'Thousand Separator:
    Dim v_csv_thousand_sep As String = "."
    'Comma:
    Dim v_csv_comma_sep As String = ","

    Dim v_ignore_duplicates_possible As Boolean = False

#Region "Mapped"

    <Key>
    Public Property Id As Integer
        Get
            Return v_id
        End Get
        Set(value As Integer)
            If v_id <> value Then
                v_id = value
                NotifyPropertyChanged("Id")
            End If
        End Set
    End Property

    Public Property bezeichnung As String
        Get
            Return v_bezeichnung
        End Get
        Set(value As String)
            If v_bezeichnung <> value Then
                v_bezeichnung = value
                NotifyPropertyChanged("bezeichnung")
            End If
        End Set
    End Property

    Public Property csv_textqualifier As String
        Get
            Return v_csv_textqualifier
        End Get
        Set(value As String)
            If v_csv_textqualifier <> value Then
                v_csv_textqualifier = value
                NotifyPropertyChanged("csv_textqualifier")
            End If
        End Set
    End Property

    Public Property csv_thousand_sep As String
        Get
            Return v_csv_thousand_sep
        End Get
        Set(value As String)
            If v_csv_thousand_sep <> value Then
                v_csv_thousand_sep = value
                NotifyPropertyChanged("csv_thousand_sep")
            End If
        End Set
    End Property

    Public Property csv_comma_sep As String
        Get
            Return v_csv_comma_sep
        End Get
        Set(value As String)
            If v_csv_comma_sep <> value Then
                v_csv_comma_sep = value
                NotifyPropertyChanged("csv_comma_sep")
            End If
        End Set
    End Property

    Public Property ignore_duplicates_possible As Boolean
        Get
            Return v_ignore_duplicates_possible
        End Get
        Set(value As Boolean)
            If v_ignore_duplicates_possible <> value Then
                v_ignore_duplicates_possible = value
                NotifyPropertyChanged("ignore_duplicates_possible")
            End If
        End Set
    End Property

#End Region

#Region "Navigation Properties"

    Public Overridable Property import_definition_entries As New ObservableCollection(Of bookjournal_import_definition_entry_v01)
#End Region


#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "bezeichnung"
                    If String.IsNullOrEmpty(bezeichnung) Then result = "Bezeichnung darf nicht leer sein"
                Case Else
                    Return result
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If
            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region


End Class
