﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.ComponentModel

''' <summary>
''' Represents the head of a booking journal with is associated to a konto
''' </summary>
Public Class bookjournal_v01
    Inherits model_base


    Sub New()
        CanClose = True
        IsClosed = False

        'Register Collections to Notify:
        _Collections = New INotifyCollectionChanged() {bookjournal_entries, RawData, RawData_Columns, vcBookJournalEntries}

    End Sub

    Public Sub reset_import()
        BookjournalEntriesTemp.Clear()
        RawData_Columns.Clear()
        RawData.Clear()
        FilePath = String.Empty
        can_import_start = False
        ignore_duplicates_possible = True
    End Sub

#Region "Mapped"

    Dim v_bj_id As Integer

    <Key>
    <ForeignKey("nv_konto_back")>
    Public Property bj_id As Integer
        Get
            Return v_bj_id
        End Get
        Set(value As Integer)
            If v_bj_id <> value Then
                v_bj_id = value
                NotifyPropertyChanged("bj_id")
            End If
        End Set
    End Property
#End Region

#Region "NotMapped"
    Public ReadOnly Property bezeichnung As String
        Get
            If nv_konto_back Is Nothing Then
                Return "Fehlerhaftes Journal"
            Else
                Return nv_konto_back.bezeichnung & " - Journal"
            End If
        End Get
    End Property

    'Dim v_rawdata As IList(Of String)
    Dim v_rawdata As New ObservableCollection(Of String)

    <NotMapped>
    Public Property RawData As ObservableCollection(Of String)
        Get
            Return v_rawdata
        End Get
        Set(value As ObservableCollection(Of String))
            If v_rawdata IsNot value Then
                v_rawdata = value
                NotifyPropertyChanged("RawData")
            End If
        End Set
    End Property

    Dim v_rawdata_columns As New ObservableCollection(Of cls_search_column_helper)
    <NotMapped>
    Public Property RawData_Columns As ObservableCollection(Of cls_search_column_helper)
        Get
            Return v_rawdata_columns
        End Get
        Set(value As ObservableCollection(Of cls_search_column_helper))
            If v_rawdata_columns IsNot value Then
                v_rawdata_columns = value
                NotifyPropertyChanged("RawData_Columns")
            End If
        End Set
    End Property

    'Public Overridable Property bookjournal_entries As New ObservableCollection(Of bookjournal_entry_v01)
    Dim v_bookjournal_entries_temp As New ObservableCollection(Of bookjournal_entry_v01)
    <NotMapped>
    Public Property BookjournalEntriesTemp As ObservableCollection(Of bookjournal_entry_v01)
        Get
            Return v_bookjournal_entries_temp
        End Get
        Set(value As ObservableCollection(Of bookjournal_entry_v01))
            If v_bookjournal_entries_temp IsNot value Then
                v_bookjournal_entries_temp = value
                NotifyPropertyChanged("BookjournalEntriesTemp")
            End If
        End Set
    End Property

    Dim v_filepath As String
    <NotMapped>
    Public Property FilePath As String
        Get
            Return v_filepath
        End Get
        Set(value As String)
            If v_filepath <> value Then
                v_filepath = value
                NotifyPropertyChanged("FilePath")
            End If
        End Set
    End Property

    Dim v_csv_limiter As String = ";"
    <NotMapped>
    Public Property csv_limiter As String
        Get
            Return v_csv_limiter
        End Get
        Set(value As String)
            If v_csv_limiter <> value Then
                v_csv_limiter = value
                NotifyPropertyChanged("csv_limiter")
            End If
        End Set
    End Property

    Dim v_csv_groupseparator As String = "."
    <NotMapped>
    Public Property csv_groupseparator As String
        Get
            Return v_csv_groupseparator
        End Get
        Set(value As String)
            If v_csv_groupseparator <> value Then
                v_csv_groupseparator = value
                NotifyPropertyChanged("csv_groupseparator")
            End If
        End Set
    End Property

    Dim v_csv_textqualifier As String = """"
    <NotMapped>
    Public Property csv_textqualifier As String
        Get
            Return v_csv_textqualifier
        End Get
        Set(value As String)
            If v_csv_textqualifier <> value Then
                v_csv_textqualifier = value
                NotifyPropertyChanged("csv_textqualifier")
            End If
        End Set
    End Property

    Dim v_can_import_start As Boolean = False

    <NotMapped>
    Public Property can_import_start As Boolean
        Get
            Return v_can_import_start
        End Get
        Set(value As Boolean)
            If v_can_import_start <> value Then
                v_can_import_start = value
                NotifyPropertyChanged("can_import_start")
            End If
        End Set
    End Property

    Dim v_ignore_duplicates_possible As Boolean = True
    <NotMapped>
    Public Property ignore_duplicates_possible As Boolean
        Get
            Return v_ignore_duplicates_possible
        End Get
        Set(value As Boolean)
            If v_ignore_duplicates_possible <> value Then
                v_ignore_duplicates_possible = value
                NotifyPropertyChanged("ignore_duplicates_possible")
            End If
        End Set
    End Property


    'Property used for the selection of the GUI Datagrid:
    <NotMapped>
    Public Property SelectedObjects() As IList(Of bookjournal_entry_v01)
        Get
            Return m_SelectedObject
        End Get
        Set
            m_SelectedObject = Value
            NotifyPropertyChanged("SelectedObjects()")
        End Set
    End Property
    Private m_SelectedObject As IList(Of bookjournal_entry_v01)



    <NotMapped>
    Public Property TimeFrameCurrent As Integer
        Get
            Return m_TimeFrameCurrent
        End Get
        Set(value As Integer)
            If m_TimeFrameCurrent <> value Then
                m_TimeFrameCurrent = value
                NotifyPropertyChanged("TimeFrameCurrent")
            End If
        End Set
    End Property
    Dim m_TimeFrameCurrent As Integer = 2 'Standard is current month


    Dim m_showfrom As String = "-"
    Dim m_showto As String = "-"

    Public Sub SetShowDates(v_start As String, v_end As String)
        If v_start = "" Then v_start = "-"
        If v_end = "" Then v_end = "-"
        ShowFrom = v_start
        ShowTo = v_end
    End Sub

    <NotMapped>
    Public Property ShowFrom As String
        Get
            Return m_showfrom
        End Get
        Set(value As String)
            If m_showfrom <> value Then
                m_showfrom = value
                NotifyPropertyChanged("ShowFrom")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property ShowTo As String
        Get
            Return m_showto
        End Get
        Set(value As String)
            If m_showto <> value Then
                m_showto = value
                NotifyPropertyChanged("ShowTo")
            End If
        End Set
    End Property

    Dim v_showunlinkedonly As Boolean = False

    <NotMapped>
    Public Property ShowUnlinkedOnly As Boolean
        Get
            Return v_showunlinkedonly
        End Get
        Set(value As Boolean)
            If v_showunlinkedonly <> value Then
                v_showunlinkedonly = value
                'Call ChangeBJEntriesFilter
                NotifyPropertyChanged("ShowUnlinkedOnly")
            End If
        End Set
    End Property

    'Private Sub ChangeBJEntriesFilter()
    '    With vcBookJournalEntries

    '        .Filter = Nothing
    '        If v_showunlinkedonly Then
    '            .Filter = New Predicate(Of Object)(Function(x) DirectCast(x, bookjournal_entry_v01).nv_transaction Is Nothing)
    '        End If

    '    End With
    'End Sub


    'Private Sub ActiveLiveFiltering(ByVal collectionView As ICollectionView, ByVal involvedProperties As IList(Of String))
    '    Dim collectionViewLiveShaping = TryCast(collectionView, ICollectionViewLiveShaping)
    '    If collectionViewLiveShaping Is Nothing Then Return
    '    If collectionViewLiveShaping.CanChangeLiveFiltering Then
    '        For Each propName As String In involvedProperties
    '            collectionViewLiveShaping.LiveFilteringProperties.Add(propName)
    '        Next

    '        collectionViewLiveShaping.IsLiveFiltering = True
    '    End If
    'End Sub


#End Region

#Region "Navigation Properties"

    Public Overridable Property nv_konto_back As konto_v01

    Public Overridable Property bookjournal_entries As New ObservableCollection(Of bookjournal_entry_v01)

    <NotMapped>
    Public Property vcBookJournalEntries As New ListCollectionView(bookjournal_entries)

    Public Sub bookjournal_entries_updated()
        NotifyPropertyChanged("bookjournal_entries")
    End Sub
#End Region





#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            'Select Case columnName
            '    Case "bezeichnung"
            '        If String.IsNullOrEmpty(bezeichnung) Then result = "Bezeichnung darf nicht leer sein"
            '    Case "parent_folder_id"
            '        If parent_folder_id = Nothing Then result = "Ordner muss ausgewählt sein"
            '    Case Else
            '        Return result
            'End Select
            'If String.IsNullOrEmpty(result) Then
            '    v_haserrors = False
            'Else
            '    v_haserrors = True
            'End If

            'NotifyPropertyChanged("hasErrors")
            'Debug.Print("KontoErrorItem hasErrors " & v_haserrors.ToString)
            Return result
        End Get
    End Property
#End Region

#Region "Menüsystem"
    <NotMapped>
    Public Property cmdClose() As New RelayCommand(AddressOf Close, Function() CanClose = True)

    Private _isclosed As Boolean

    <NotMapped>
    Public Property IsClosed() As Boolean
        Get
            Return _isclosed
        End Get
        Set(value As Boolean)
            If _isclosed <> value Then
                _isclosed = value
                NotifyPropertyChanged("isClosed")
            End If
        End Set
    End Property

    Private _CanClose As Boolean = True

    <NotMapped>
    Public Property CanClose() As Boolean
        Get
            Return _CanClose
        End Get
        Set
            If _CanClose <> Value Then
                _CanClose = Value
                NotifyPropertyChanged("CanClose")
            End If
        End Set
    End Property

    Public Sub Close()
        Me.IsClosed = True
        NotifyPropertyChanged("IsClosed")
    End Sub
#End Region

End Class
