﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.ComponentModel

Public Class konto_v01
    Inherits model_base

    'Interne Variablen
    Dim v_kto_id As Integer
    Dim v_bezeichnung As String
    Dim v_color As String = "#000000"
    Dim v_symbol As Byte()
    Dim v_start_value As Decimal = 0D
    Dim v_totalamount As Decimal = 0D
    Dim v_in_vermoegen As Nullable(Of Boolean) = True
    Dim v_aktiv As Nullable(Of Boolean) = True
    Dim v_comment As String
    Dim v_inhaber As String
    Dim v_ktonr As String
    Dim v_blz As String
    Dim v_bic As String
    Dim v_iban As String
    Dim v_bankname As String
    Dim v_bankhp As String
    Dim v_bank_web As String
    Dim v_parent_folder_id As Integer
    Dim v_favorite As Nullable(Of Boolean)

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "bezeichnung"
                    If String.IsNullOrEmpty(bezeichnung) Then result = "Bezeichnung darf nicht leer sein"
                Case "parent_folder_id"
                    If parent_folder_id = Nothing Then result = "Ordner muss ausgewählt sein"
                Case Else
                    Return result
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If

            NotifyPropertyChanged("hasErrors")
            Debug.Print("KontoErrorItem hasErrors " & v_haserrors.ToString)
            Return result
        End Get
    End Property
#End Region

#Region "Mapped"
    <Key>
    Public Property kto_id As Integer
        Get
            Return v_kto_id
        End Get
        Set(value As Integer)
            If v_kto_id <> value Then
                v_kto_id = value
                NotifyPropertyChanged("kto_id")
            End If
        End Set
    End Property

    Public Property bezeichnung As String
        Get
            Return v_bezeichnung
        End Get
        Set(value As String)
            If v_bezeichnung <> value Then
                v_bezeichnung = value
                NotifyPropertyChanged("bezeichnung")
                NotifyPropertyChanged("bezeichnung_gal")
            End If
        End Set
    End Property

    Public Property color As String
        Get
            Return v_color
        End Get
        Set(value As String)
            If v_color <> value Then
                v_color = value
                NotifyPropertyChanged("color")
            End If
        End Set
    End Property

    <MaxLength>
    Public Property symbol As Byte()
        Get
            Return v_symbol
        End Get
        Set(value As Byte())
            If v_symbol IsNot value Then
                v_symbol = value
                NotifyPropertyChanged("symbol")
                NotifyPropertyChanged("symbol_ever")
            End If
        End Set
    End Property

    Public Property start_value As Decimal
        Get
            Return v_start_value
        End Get
        Set(value As Decimal)
            If v_start_value <> value Then
                v_start_value = value
                NotifyPropertyChanged("start_value")
            End If
        End Set
    End Property

    ''' <summary>
    ''' Gesamtsumme des Kontos 
    ''' </summary>
    ''' <returns></returns>
    Public Property Totalamount As Decimal
        Get
            Return v_totalamount
        End Get
        Set(value As Decimal)
            If v_totalamount <> value Then
                v_totalamount = value
                NotifyPropertyChanged("Totalamount")
            End If
        End Set
    End Property

    Public Property in_vermoegen As Nullable(Of Boolean)
        Get
            Return v_in_vermoegen
        End Get
        Set(value As Nullable(Of Boolean))
            If Not v_in_vermoegen.Equals(value) Then
                v_in_vermoegen = value
                NotifyPropertyChanged("in_vermoegen")
            End If
        End Set
    End Property

    Public Property aktiv As Nullable(Of Boolean)
        Get
            Return v_aktiv
        End Get
        Set(value As Nullable(Of Boolean))
            If Not v_aktiv.Equals(value) Then
                v_aktiv = value
                NotifyPropertyChanged("aktiv")
            End If
        End Set
    End Property

    Public Property comment As String
        Get
            Return v_comment
        End Get
        Set(value As String)
            If v_comment <> value Then
                v_comment = value
                NotifyPropertyChanged("comment")
            End If
        End Set
    End Property

    Public Property inhaber As String
        Get
            Return v_inhaber
        End Get
        Set(value As String)
            If v_inhaber <> value Then
                v_inhaber = value
                NotifyPropertyChanged("inhaber")
            End If
        End Set
    End Property

    Public Property ktonr As String
        Get
            Return v_ktonr
        End Get
        Set(value As String)
            If v_ktonr <> value Then
                v_ktonr = value
                NotifyPropertyChanged("ktonr")
            End If
        End Set
    End Property

    Public Property blz As String
        Get
            Return v_blz
        End Get
        Set(value As String)
            If v_blz <> value Then
                v_blz = value
                NotifyPropertyChanged("blz")
            End If
        End Set
    End Property

    Public Property bic As String
        Get
            Return v_bic
        End Get
        Set(value As String)
            If v_bic <> value Then
                v_bic = value
                NotifyPropertyChanged("bic")
            End If
        End Set
    End Property

    Public Property iban As String
        Get
            Return v_iban
        End Get
        Set(value As String)
            If v_iban <> value Then
                v_iban = value
                NotifyPropertyChanged("iban")
            End If
        End Set
    End Property

    Public Property bankname As String
        Get
            Return v_bankname
        End Get
        Set(value As String)
            If v_bankname <> value Then
                v_bankname = value
                NotifyPropertyChanged("bankname")
            End If
        End Set
    End Property

    Public Property bankhp As String
        Get
            Return v_bankhp
        End Get
        Set(value As String)
            If v_bankhp <> value Then
                v_bankhp = value
                NotifyPropertyChanged("bankhp")
            End If
        End Set
    End Property

    Public Property bank_web As String
        Get
            Return v_bank_web
        End Get
        Set(value As String)
            If v_bank_web <> value Then
                v_bank_web = value
                NotifyPropertyChanged("bank_web")
            End If
        End Set
    End Property

    Public Property parent_folder_id As Integer
        Get
            Return v_parent_folder_id
        End Get
        Set(value As Integer)
            If v_parent_folder_id <> value Then
                v_parent_folder_id = value
                NotifyPropertyChanged("parent_folder_id")
            End If
        End Set
    End Property

    Public Property favorite As Nullable(Of Boolean)
        Get
            Return v_favorite
        End Get
        Set(value As Nullable(Of Boolean))
            If Not v_favorite.Equals(value) Then
                v_favorite = value
                NotifyPropertyChanged("favorite")
            End If
        End Set
    End Property

#End Region

#Region "Navigation Properties"

    Dim v_nv_folder_2_konto_back As folder_v01

    <ForeignKey("parent_folder_id")>
    Public Property nv_folder_2_konto_back As folder_v01
        Get
            Return v_nv_folder_2_konto_back
        End Get
        Set(value As folder_v01)
            If v_nv_folder_2_konto_back IsNot value Then
                v_nv_folder_2_konto_back = value
                NotifyPropertyChanged("nv_folder_2_konto_back")
            End If
        End Set
    End Property
    <ForeignKey("konto_id")>
    Public Overridable Property nv_kto_2_trans As New ObservableCollection(Of transactions_v01)
    <ForeignKey("to_konto_id")>
    Public Overridable Property nv_kto_2_trans_transfer As New ObservableCollection(Of transactions_v01)

    Public Overridable Property nv_kto_2_bookjournal As bookjournal_v01

    Public Overridable Property nv_kto_2_savingtargets As New ObservableCollection(Of savingtargets_v01)

#End Region

#Region "Extension"
    ''' <summary>
    ''' Property offers a SolidColorBrush out of the String HTML Color to change Foreground Color of an Item.
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property solid_color() As SolidColorBrush
        Get
            If color Is Nothing Then
                Return ColorBrushFromResources("IdealForegroundColorBrush")
            Else
                Try
                    Dim v_col As System.Drawing.Color = System.Drawing.ColorTranslator.FromHtml(color)
                    Dim v_color As Color = System.Windows.Media.Color.FromArgb(v_col.A, v_col.R, v_col.G, v_col.B)
                    Return New SolidColorBrush(v_color)
                Catch ex As Exception
                    Return ColorBrushFromResources("IdealForegroundColorBrush")
                End Try
            End If
        End Get
    End Property

    Public ReadOnly Property symbol_ever() As Byte()
        Get
            If symbol Is Nothing Then
                Return ResourceDictionaryImagetoByte("Konto")
            Else
                Return symbol
            End If
        End Get
    End Property

    ''' <summary>
    ''' Property die einen ToolTip Text zurückgibt
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property ToolTipText As String
        Get
            Dim v_text As String = String.Concat("Kontostand: ", String.Format("{0:C}", Totalamount), Environment.NewLine)
            If Not inhaber = "" Then v_text &= String.Concat("Inhaber: ", inhaber, Environment.NewLine)
            If Not ktonr = "" Then v_text &= String.Concat("Kontonummer: ", ktonr, Environment.NewLine)
            If Not bankname = "" Then v_text &= String.Concat("Bank: ", bankname)
            v_text &= Environment.NewLine
            v_text &= comment
            Return v_text
        End Get
    End Property

    Public Sub Totalamount_Calculate()
        'Total amount of the account
        Dim v_pos_values As Decimal = nv_kto_2_trans.Where(Function(x) x.nv_transtyp_trans_back.multiplier = 1).Sum(Function(x) x.real_totamount)
        'Debug.Print(String.Format("Kontoname: {0} v_pos_values: {1}", bezeichnung, v_pos_values))
        Dim v_neg_values As Decimal = nv_kto_2_trans.Where(Function(x) x.nv_transtyp_trans_back.multiplier = -1).Sum(Function(x) x.totamount)
        'Debug.Print(String.Format("Kontoname: {0} v_pos_values: {1}", bezeichnung, v_neg_values))

        v_pos_values += nv_kto_2_trans_transfer.Sum(Function(x) x.totamount)
        'Debug.Print(String.Format("Kontoname: {0} v_pos_values after transfer: {1}", bezeichnung, v_pos_values))
        v_neg_values += nv_kto_2_trans.Where(Function(x) x.nv_transtyp_trans_back.multiplier = 0).Sum(Function(x) x.totamount)
        'Debug.Print(String.Format("Kontoname: {0} v_neg_values after transfer: {1}", bezeichnung, v_pos_values))

        Totalamount = start_value + v_pos_values - v_neg_values
        'Debug.Print(String.Format("Kontoname: {0} Totalamount: {1}", bezeichnung, Totalamount))
        notify_kontovaluechange()
    End Sub


    ''' <summary>
    ''' Calculated the totalamount of an account within a given timefrange
    ''' </summary>
    ''' <param name="v_begin">From Date</param>
    ''' <param name="v_end">To Date</param>
    ''' <returns>Totalamount of the account</returns>
    Public Function TotalamountTimeFrame(v_begin As Date, v_end As Date, with_startvalue As Boolean) As Decimal
        If v_begin = Nothing OrElse v_end = Nothing Then Return 0

        'Total amount of the account
        Dim v_pos_values As Decimal = nv_kto_2_trans.Where(Function(x) x.nv_transtyp_trans_back.multiplier = 1 AndAlso x.datum >= v_begin AndAlso x.datum <= v_end).Sum(Function(x) x.real_totamount)
        Dim v_neg_values As Decimal = nv_kto_2_trans.Where(Function(x) x.nv_transtyp_trans_back.multiplier = -1 AndAlso x.datum >= v_begin AndAlso x.datum <= v_end).Sum(Function(x) x.totamount)

        v_pos_values += nv_kto_2_trans_transfer.Where(Function(x) x.datum >= v_begin AndAlso x.datum <= v_end).Sum(Function(x) x.totamount)
        v_neg_values += nv_kto_2_trans.Where(Function(x) x.nv_transtyp_trans_back.multiplier = 0 AndAlso x.datum >= v_begin AndAlso x.datum <= v_end).Sum(Function(x) x.totamount)

        If with_startvalue Then
            Return start_value + v_pos_values - v_neg_values
        Else
            Return v_pos_values - v_neg_values
        End If

    End Function


    Public ReadOnly Property ContextBezeichnung As String
        Get
            Return String.Concat(bezeichnung, "Befehle")
        End Get
    End Property

    Private _suspender As New ActionFrame(AddressOf SuspendEvents)
    <NotMapped>
    Private WithEvents MixedChildren As New ObservableCollection(Of Object)
    <NotMapped>
    Public Property cvMixedChildren As New ListCollectionView(MixedChildren)

    Sub New()
        CanClose = True
        IsClosed = False
        _Collections = New INotifyCollectionChanged() {nv_kto_2_trans, nv_kto_2_trans_transfer, MixedChildren}
        Using _suspender.Enter
            MixedChildren.AddRangeAt(nv_kto_2_trans.Cast(Of Object).Concat(nv_kto_2_trans_transfer))
            With cvMixedChildren
                .MoveCurrentToFirst()
                .LiveSortingProperties.Add("datum")
                .IsLiveSorting = True
            End With
        End Using
    End Sub

    Private Sub SuspendEvents(suspend As Boolean)
        If suspend Then
            _Collections.ForEach(Sub(c) RemoveHandler c.CollectionChanged, AddressOf Collection_CollectionChanged)
        Else
            _Collections.ForEach(Sub(c) AddHandler c.CollectionChanged, AddressOf Collection_CollectionChanged)
        End If
    End Sub

    Private Sub Collection_CollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs)
        Using _suspender.Enter
            If sender Is MixedChildren Then
                Select Case e.Action
                    Case NotifyCollectionChangedAction.Add
                        Dim m = TryCast(e.NewItems(0), transactions_v01)
                        If m IsNot Nothing Then
                            nv_kto_2_trans.Insert(e.NewStartingIndex, m)
                        Else
                            Dim w = DirectCast(e.NewItems(0), transactions_v01)
                            nv_kto_2_trans_transfer.Insert(e.NewStartingIndex + nv_kto_2_trans.Count, w)
                        End If
                    Case NotifyCollectionChangedAction.Remove
                        Dim m = TryCast(e.OldItems(0), transactions_v01)
                        If m IsNot Nothing Then
                            nv_kto_2_trans.RemoveAt(e.OldStartingIndex)
                        Else
                            nv_kto_2_trans_transfer.RemoveAt(e.OldStartingIndex + nv_kto_2_trans.Count)
                        End If
                    Case NotifyCollectionChangedAction.Reset
                        Throw New NotImplementedException
                    Case NotifyCollectionChangedAction.Replace
                        Dim m = TryCast(e.NewItems(0), transactions_v01)
                        If m IsNot Nothing Then
                            nv_kto_2_trans(e.NewStartingIndex) = m
                        Else
                            Dim w = DirectCast(e.NewItems(0), transactions_v01)
                            nv_kto_2_trans_transfer(e.NewStartingIndex + nv_kto_2_trans.Count) = w
                        End If
                End Select
            Else
                Dim offset = If(sender Is nv_kto_2_trans, 0, nv_kto_2_trans.Count)
                Select Case e.Action
                    Case NotifyCollectionChangedAction.Add
                        MixedChildren.Insert(e.NewStartingIndex + offset, e.NewItems(0))

                    Case NotifyCollectionChangedAction.Remove
                        MixedChildren.RemoveAt(e.OldStartingIndex + offset)
                    Case NotifyCollectionChangedAction.Reset
                        Dim ubound = If(sender Is nv_kto_2_trans, nv_kto_2_trans.Count, MixedChildren.Count) - 1
                        For i = ubound To offset Step -1
                            MixedChildren.RemoveAt(i)

                        Next
                        MixedChildren.AddRangeAt(DirectCast(sender, System.Collections.IList).Cast(Of Object), offset)

                    Case NotifyCollectionChangedAction.Replace
                        MixedChildren(e.NewStartingIndex + offset) = e.NewItems(0)
                End Select
            End If
        End Using

    End Sub

    ''' <summary>
    ''' Notifies the GUI that the Konto totamount and also ToolTipText have changed
    ''' </summary>
    Public Sub notify_kontovaluechange()
        NotifyPropertyChanged("Totalamount")
        NotifyPropertyChanged("ToolTipText")
    End Sub

    <NotMapped>
    Public Property SelectedObject() As IList(Of transactions_v01)
        Get
            Return m_SelectedObject
        End Get
        Set
            m_SelectedObject = Value
            NotifyPropertyChanged("SelectedObject()")
        End Set
    End Property
    Private m_SelectedObject As IList(Of transactions_v01)

    'Properties for StatusAmount
    Private WithEvents v_statusamounts As New ObservableCollection(Of cls_statusamount)
    <NotMapped>
    Public Property StatusAmounts As ObservableCollection(Of cls_statusamount)
        Get
            Return v_statusamounts
        End Get
        Set(value As ObservableCollection(Of cls_statusamount))
            If v_statusamounts IsNot value Then
                v_statusamounts = value
                NotifyPropertyChanged("StatusAmounts")
            End If
        End Set
    End Property

    'Properties for statistic system:

    Dim v_stat_min As Decimal = 0D
    Dim v_stat_max As Decimal = 0D
    Dim v_stat_sum As Decimal = 0D
    Dim v_stat_avg As Decimal = 0D
    Dim v_stat_stddev As Decimal = 0D
    Dim v_stat_count As Integer = 0

    <NotMapped>
    Public Property Stat_Min As Decimal
        Get
            Return v_stat_min
        End Get
        Set(value As Decimal)
            If v_stat_min <> value Then
                v_stat_min = value
                NotifyPropertyChanged("Stat_Min")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property Stat_Max As Decimal
        Get
            Return v_stat_max
        End Get
        Set(value As Decimal)
            If v_stat_max <> value Then
                v_stat_max = value
                NotifyPropertyChanged("Stat_Max")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property Stat_Sum As Decimal
        Get
            Return v_stat_sum
        End Get
        Set(value As Decimal)
            If v_stat_sum <> value Then
                v_stat_sum = value
                NotifyPropertyChanged("Stat_Sum")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property Stat_Avg As Decimal
        Get
            Return Decimal.Round(v_stat_avg, 2)
        End Get
        Set(value As Decimal)
            If v_stat_avg <> value Then
                v_stat_avg = value
                NotifyPropertyChanged("Stat_Avg")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property Stat_StdDev As Decimal
        Get
            Return Decimal.Round(v_stat_stddev, 2)
        End Get
        Set(value As Decimal)
            If v_stat_stddev <> value Then
                v_stat_stddev = value
                NotifyPropertyChanged("Stat_StdDev")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property Stat_Count As Integer
        Get
            Return v_stat_count
        End Get
        Set(value As Integer)
            If v_stat_count <> value Then
                v_stat_count = value
                NotifyPropertyChanged("Stat_Count")
            End If
        End Set
    End Property

    Dim v_filterextendeduse As Boolean = False
    ''' <summary>
    ''' Defines if an extended Filter is overwriting the TimeFrame to show.
    ''' </summary>
    ''' <returns></returns>
    <NotMapped>
    Public Property FilterExtendedUse As Boolean
        Get
            Return v_filterextendeduse
        End Get
        Set(value As Boolean)
            If v_filterextendeduse <> value Then
                v_filterextendeduse = value
                NotifyPropertyChanged("FilterExtendedUse")
            End If
            If value Then ChangeFilterNecessary = False
        End Set
    End Property

    Dim v_filter_ext_definition As New cls_filter_extended
    <NotMapped>
    Public Property filter_ext_definition As cls_filter_extended
        Get
            Return v_filter_ext_definition
        End Get
        Set(value As cls_filter_extended)
            If v_filter_ext_definition IsNot value Then
                v_filter_ext_definition = value
                NotifyPropertyChanged("v_filter_ext_definition")
            End If
        End Set
    End Property

    Dim v_isbusy As Boolean = False
    <NotMapped>
    Public Property isBusy As Boolean
        Get
            Return v_isbusy
        End Get
        Set(value As Boolean)
            If v_isbusy <> value Then
                v_isbusy = value
                NotifyPropertyChanged("isBusy")
            End If
        End Set
    End Property


    <NotMapped>
    Public Property TimeFrameCurrent As Integer
        Get
            Return m_TimeFrameCurrent
        End Get
        Set(value As Integer)
            If m_TimeFrameCurrent <> value Then
                m_TimeFrameCurrent = value
                ChangeFilterNecessary = True
                NotifyPropertyChanged("TimeFrameCurrent")
            Else
                ChangeFilterNecessary = False
            End If
        End Set
    End Property
    Dim m_TimeFrameCurrent As Integer = 2 'Standard is current month

    <NotMapped>
    Public Property ChangeFilterNecessary As Boolean
        Get
            Return m_ChangeFilterNecessary
        End Get
        Set(value As Boolean)
            If m_ChangeFilterNecessary <> value Then
                m_ChangeFilterNecessary = value
                NotifyPropertyChanged("ChangeFilterNecessary")
            End If
        End Set
    End Property
    Dim m_ChangeFilterNecessary As Boolean = True

    Dim m_showfrom As String = "-"
    Dim m_showto As String = "-"

    Public Sub SetShowDates(v_start As String, v_end As String)
        If v_start = "" Then v_start = "-"
        If v_end = "" Then v_end = "-"
        ShowFrom = v_start
        ShowTo = v_end
    End Sub

    <NotMapped>
    Public Property ShowFrom As String
        Get
            Return m_showfrom
        End Get
        Set(value As String)
            If m_showfrom <> value Then
                m_showfrom = value
                NotifyPropertyChanged("ShowFrom")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property ShowTo As String
        Get
            Return m_showto
        End Get
        Set(value As String)
            If m_showto <> value Then
                m_showto = value
                NotifyPropertyChanged("ShowTo")
            End If
        End Set
    End Property


    ''' <summary>
    ''' Property for Archiv to define the String Type of the Object
    ''' </summary>
    ''' <returns></returns>
    <NotMapped>
    Public ReadOnly Property object_type As String
        Get
            Return "Konto"
        End Get
    End Property

    ''' <summary>
    ''' Property bezeichnung with reduced length (10 chars)
    ''' for use in Ribbon Gallery
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property bezeichnung_gal As String
        Get
            If bezeichnung.Length > 10 Then
                Return bezeichnung.Substring(0, 10)
            Else
                Return bezeichnung
            End If
        End Get
    End Property

    Public ReadOnly Property bezeichnung_full As String
        Get
            Return nv_folder_2_konto_back.bezeichnung & " - " & bezeichnung
        End Get
    End Property

#End Region

#Region "Menüsystem"
    <NotMapped>
    Public Property cmdClose() As New RelayCommand(AddressOf Close, Function() CanClose = True)

    Private _isclosed As Boolean

    <NotMapped>
    Public Property IsClosed() As Boolean
        Get
            Return _isclosed
        End Get
        Set(value As Boolean)
            If _isclosed <> value Then
                _isclosed = value
                NotifyPropertyChanged("isClosed")
            End If
        End Set
    End Property

    Private _CanClose As Boolean = True

    <NotMapped>
    Public Property CanClose() As Boolean
        Get
            Return _CanClose
        End Get
        Set
            If _CanClose <> Value Then
                _CanClose = Value
                NotifyPropertyChanged("CanClose")
            End If
        End Set
    End Property

    Public Sub Close()
        Debug.Print("Close execute")
        Me.IsClosed = True
        NotifyPropertyChanged("IsClosed")
        Debug.Print("Close executed")
    End Sub
#End Region

End Class


