﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Threading
Imports System.Collections.Specialized

Public Class searchdefinition_v01
    Inherits model_base

    'Interne Variablen
    Dim v_search_id As Integer
    Dim v_search_bezeichnung As String = "Neue Suche"
    Dim v_color As String = "#000000"
    Dim v_symbol As Byte()
    Dim v_created_at As Date = Date.Now
    'Property for Standard Search:
    Dim v_aktiv_category As Boolean = False
    Dim v_aktiv_konto As Boolean = False
    Dim v_aktiv_tokonto As Boolean = False
    Dim v_aktiv_person As Boolean = False
    Dim v_aktiv_receiver As Boolean = False
    Dim v_aktiv_status As Boolean = False
    Dim v_aktiv_time As Boolean = False
    Dim v_aktiv_typ As Boolean = False
    Dim v_aktiv_value As Boolean = False
    Dim v_aktiv_note As Boolean = False
    Dim v_aktiv_tag As Boolean = False
    Dim v_search_category As Nullable(Of Integer)
    Dim v_search_category_subcats As Boolean = False
    Dim v_search_konto As Nullable(Of Integer)
    Dim v_search_tokonto As Nullable(Of Integer)
    Dim v_search_person As Nullable(Of Integer)
    Dim v_search_receiver As Nullable(Of Integer)
    Dim v_search_status As Nullable(Of Integer)
    Dim v_search_time_from As Nullable(Of Date) = Date.Now.AddDays(-7)
    Dim v_search_time_to As Nullable(Of Date) = Date.Now
    Dim v_search_typ As Nullable(Of Integer)
    Dim v_search_tag As Nullable(Of Integer)
    Dim v_search_value_from As Nullable(Of Decimal) = 0D
    Dim v_search_value_to As Nullable(Of Decimal) = 0D
    Dim v_search_note As String
    Dim v_search_note_exact As Boolean = False


#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "search_bezeichnung"
                    If String.IsNullOrEmpty(search_bezeichnung) Then result = "Bezeichnung darf nicht leer sein"
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If
            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region

#Region "Mapped"
    <Key>
    Public Property search_id As Integer
        Get
            Return v_search_id
        End Get
        Set(value As Integer)
            If v_search_id <> value Then
                v_search_id = value
                NotifyPropertyChanged("search_id")
            End If
        End Set
    End Property

    Public Property search_bezeichnung As String
        Get
            Return v_search_bezeichnung
        End Get
        Set(value As String)
            If v_search_bezeichnung <> value Then
                v_search_bezeichnung = value
                NotifyPropertyChanged("search_bezeichnung")
                NotifyPropertyChanged("search_bezeichnung_gal")
            End If
        End Set
    End Property

    Public Property color As String
        Get
            Return v_color
        End Get
        Set(value As String)
            If v_color <> value Then
                v_color = value
                NotifyPropertyChanged("color")
            End If
        End Set
    End Property

    <MaxLength>
    Public Property symbol As Byte()
        Get
            Return v_symbol
        End Get
        Set(value As Byte())
            If v_symbol IsNot value Then
                v_symbol = value
                NotifyPropertyChanged("symbol")
                NotifyPropertyChanged("symbol_ever")
            End If
        End Set
    End Property

    Public Property created_at As Date
        Get
            Return v_created_at
        End Get
        Set(value As Date)
            If v_created_at <> value Then
                v_created_at = value
                NotifyPropertyChanged("created_at")
            End If
        End Set
    End Property

    Public Property aktiv_category As Boolean
        Get
            Return v_aktiv_category
        End Get
        Set(value As Boolean)
            If v_aktiv_category <> value Then
                v_aktiv_category = value
                NotifyPropertyChanged("aktiv_category")
            End If
        End Set
    End Property

    Public Property aktiv_konto As Boolean
        Get
            Return v_aktiv_konto
        End Get
        Set(value As Boolean)
            If v_aktiv_konto <> value Then
                v_aktiv_konto = value
                NotifyPropertyChanged("aktiv_konto")
            End If
        End Set
    End Property

    Public Property aktiv_tokonto As Boolean
        Get
            Return v_aktiv_tokonto
        End Get
        Set(value As Boolean)
            If v_aktiv_tokonto <> value Then
                v_aktiv_tokonto = value
                NotifyPropertyChanged("aktiv_tokonto")
            End If
        End Set
    End Property

    Public Property aktiv_person As Boolean
        Get
            Return v_aktiv_person
        End Get
        Set(value As Boolean)
            If v_aktiv_person <> value Then
                v_aktiv_person = value
                NotifyPropertyChanged("aktiv_person")
            End If
        End Set
    End Property

    Public Property aktiv_receiver As Boolean
        Get
            Return v_aktiv_receiver
        End Get
        Set(value As Boolean)
            If v_aktiv_receiver <> value Then
                v_aktiv_receiver = value
                NotifyPropertyChanged("aktiv_receiver")
            End If
        End Set
    End Property

    Public Property aktiv_status As Boolean
        Get
            Return v_aktiv_status
        End Get
        Set(value As Boolean)
            If v_aktiv_status <> value Then
                v_aktiv_status = value
                NotifyPropertyChanged("aktiv_status")
            End If
        End Set
    End Property

    Public Property aktiv_time As Boolean
        Get
            Return v_aktiv_time
        End Get
        Set(value As Boolean)
            If v_aktiv_time <> value Then
                v_aktiv_time = value
                NotifyPropertyChanged("aktiv_time")
            End If
        End Set
    End Property

    Public Property aktiv_typ As Boolean
        Get
            Return v_aktiv_typ
        End Get
        Set(value As Boolean)
            If v_aktiv_typ <> value Then
                v_aktiv_typ = value
                NotifyPropertyChanged("aktiv_typ")
            End If
        End Set
    End Property

    Public Property aktiv_value As Boolean
        Get
            Return v_aktiv_value
        End Get
        Set(value As Boolean)
            If v_aktiv_value <> value Then
                v_aktiv_value = value
                NotifyPropertyChanged("aktiv_value")
            End If
        End Set
    End Property

    Public Property aktiv_note As Boolean
        Get
            Return v_aktiv_note
        End Get
        Set(value As Boolean)
            If v_aktiv_note <> value Then
                v_aktiv_note = value
                NotifyPropertyChanged("aktiv_note")
            End If
        End Set
    End Property

    Public Property search_category As Nullable(Of Integer)
        Get
            Return v_search_category
        End Get
        Set(value As Nullable(Of Integer))
            If Not v_search_category.Equals(value) Then
                v_search_category = value
                NotifyPropertyChanged("search_category")
            End If
        End Set
    End Property
    Public Property search_category_subcats As Boolean
        Get
            Return v_search_category_subcats
        End Get
        Set(value As Boolean)
            If Not v_search_category_subcats.Equals(value) Then
                v_search_category_subcats = value
                NotifyPropertyChanged("search_category_subcats")
            End If
        End Set
    End Property
    Public Property search_konto As Nullable(Of Integer)
        Get
            Return v_search_konto
        End Get
        Set(value As Nullable(Of Integer))
            If Not v_search_konto.Equals(value) Then
                v_search_konto = value
                NotifyPropertyChanged("search_konto")
            End If
        End Set
    End Property
    Public Property search_tokonto As Nullable(Of Integer)
        Get
            Return v_search_tokonto
        End Get
        Set(value As Nullable(Of Integer))
            If Not v_search_tokonto.Equals(value) Then
                v_search_tokonto = value
                NotifyPropertyChanged("search_tokonto")
            End If
        End Set
    End Property
    Public Property search_person As Nullable(Of Integer)
        Get
            Return v_search_person
        End Get
        Set(value As Nullable(Of Integer))
            If Not v_search_person.Equals(value) Then
                v_search_person = value
                NotifyPropertyChanged("search_person")
            End If
        End Set
    End Property
    Public Property search_receiver As Nullable(Of Integer)
        Get
            Return v_search_receiver
        End Get
        Set(value As Nullable(Of Integer))
            If Not v_search_receiver.Equals(value) Then
                v_search_receiver = value
                NotifyPropertyChanged("search_receiver")
            End If
        End Set
    End Property
    Public Property search_status As Nullable(Of Integer)
        Get
            Return v_search_status
        End Get
        Set(value As Nullable(Of Integer))
            If Not v_search_status.Equals(value) Then
                v_search_status = value
                NotifyPropertyChanged("search_status")
            End If
        End Set
    End Property
    Public Property search_time_from As Nullable(Of Date)
        Get
            Return v_search_time_from
        End Get
        Set(value As Nullable(Of Date))
            If Not v_search_time_from.Equals(value) Then
                v_search_time_from = value
                NotifyPropertyChanged("search_time_from")
            End If
        End Set
    End Property
    Public Property search_time_to As Nullable(Of Date)
        Get
            Return v_search_time_to
        End Get
        Set(value As Nullable(Of Date))
            If Not v_search_time_to.Equals(value) Then
                v_search_time_to = value
                NotifyPropertyChanged("search_time_to")
            End If
        End Set
    End Property
    Public Property search_typ As Nullable(Of Integer)
        Get
            Return v_search_typ
        End Get
        Set(value As Nullable(Of Integer))
            If Not v_search_typ.Equals(value) Then
                v_search_typ = value
                NotifyPropertyChanged("search_typ")
            End If
        End Set
    End Property
    Public Property search_value_from As Nullable(Of Decimal)
        Get
            Return v_search_value_from
        End Get
        Set(value As Nullable(Of Decimal))
            If Not v_search_value_from.Equals(value) Then
                v_search_value_from = value
                NotifyPropertyChanged("search_value_from")
            End If
        End Set
    End Property
    Public Property search_value_to As Nullable(Of Decimal)
        Get
            Return v_search_value_to
        End Get
        Set(value As Nullable(Of Decimal))
            If Not v_search_value_to.Equals(value) Then
                v_search_value_to = value
                NotifyPropertyChanged("search_value_to")
            End If
        End Set
    End Property
    Public Property search_note As String
        Get
            Return v_search_note
        End Get
        Set(value As String)
            If v_search_note <> value Then
                v_search_note = value
                NotifyPropertyChanged("search_note")
            End If
        End Set
    End Property
    Public Property search_note_exact As Boolean
        Get
            Return v_search_note_exact
        End Get
        Set(value As Boolean)
            If Not v_search_note_exact.Equals(value) Then
                v_search_note_exact = value
                NotifyPropertyChanged("search_note_exact")
            End If
        End Set
    End Property
    Public Property aktiv_tag As Boolean
        Get
            Return v_aktiv_tag
        End Get
        Set(value As Boolean)
            If v_aktiv_tag <> value Then
                v_aktiv_tag = value
                NotifyPropertyChanged("aktiv_tag")
            End If
        End Set
    End Property

    Public Property search_tag As Nullable(Of Integer)
        Get
            Return v_search_tag
        End Get
        Set(value As Nullable(Of Integer))
            If Not v_search_tag.Equals(value) Then
                v_search_tag = value
                NotifyPropertyChanged("search_tag")
            End If
        End Set
    End Property
#End Region

#Region "Navigation Properties"

    Public Overridable Property nv_search_2_searchitem As New ObservableCollection(Of searchitem_v01)
#End Region

#Region "Menüsystem"
    <NotMapped>
    Public Property cmdClose() As New RelayCommand(AddressOf Close, Function() CanClose = True)

    Private _isclosed As Boolean

    <NotMapped>
    Public Property IsClosed() As Boolean
        Get
            Return _isclosed
        End Get
        Set(value As Boolean)
            If _isclosed <> value Then
                _isclosed = value
                NotifyPropertyChanged("IsClosed")
            End If
        End Set
    End Property

    Private _CanClose As Boolean = True

    <NotMapped>
    Public Property CanClose() As Boolean
        Get
            Return _CanClose
        End Get
        Set
            If _CanClose <> Value Then
                _CanClose = Value
                NotifyPropertyChanged("CanClose")
            End If
        End Set
    End Property

    Public Sub Close()
        Me.IsClosed = True
        NotifyPropertyChanged("IsClosed")
    End Sub

    Sub New()
        CanClose = True
        IsClosed = False
        _Collections = New INotifyCollectionChanged() {SearchResults}

    End Sub
#End Region

#Region "NotMapped"
    'Property for busy indicator
    Dim v_busy As Boolean = False
    <NotMapped>
    Property is_busy As Boolean
        Get
            Return v_busy
        End Get
        Set(value As Boolean)
            v_busy = value
            NotifyPropertyChanged("is_busy")
        End Set
    End Property

    Dim v_searchresults As ListCollectionView
    <NotMapped>
    Public Property SearchResults As ListCollectionView 'Internal Collection for listing the search results
        Get
            Return v_searchresults
        End Get
        Set(value As ListCollectionView)
            v_searchresults = value
            NotifyPropertyChanged("SearchResults")
            NotifyPropertyChanged("SearchResults_Value")
        End Set
    End Property

    Public ReadOnly Property SearchResults_Value As Decimal
        Get
            If SearchResults Is Nothing Then
                Return 0D
            ElseIf SearchResults.Count = 0 Then
                Return 0D
            Else
                Dim v_values As Decimal = 0
                For Each item As transactions_v01 In SearchResults
                    v_values += item.real_totamount
                Next
                Return v_values
            End If
        End Get
    End Property

    ''' <summary>
    ''' Property offers a SolidColorBrush out of the String HTML Color to change Foreground Color of an Item.
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property solid_color() As SolidColorBrush
        Get
            If color Is Nothing Then
                Return ColorBrushFromResources("IdealForegroundColorBrush")
            Else
                Try
                    Dim v_col As System.Drawing.Color = System.Drawing.ColorTranslator.FromHtml(color)
                    Dim v_color As Color = System.Windows.Media.Color.FromArgb(v_col.A, v_col.R, v_col.G, v_col.B)
                    Return New SolidColorBrush(v_color)
                Catch ex As Exception
                    Return ColorBrushFromResources("IdealForegroundColorBrush")
                End Try
            End If
        End Get
    End Property

    Public ReadOnly Property symbol_ever() As Byte()
        Get
            If symbol Is Nothing Then
                Return ResourceDictionaryImagetoByte("Search")
            Else
                Return symbol
            End If
        End Get
    End Property


    Dim v_sql As String = ""
    <NotMapped>
    Public Property SQLQuery As String
        Get
            Return v_sql
        End Get
        Set(value As String)
            If v_sql <> value Then
                v_sql = value
                NotifyPropertyChanged("SQLQuery")
            End If
        End Set
    End Property

    'Property to check the current selected Items in the Datagrid of the ucl_search Form
    <NotMapped>
    Public Property SelectedObject() As IList(Of transactions_v01)
        Get
            Return m_SelectedObject
        End Get
        Set
            m_SelectedObject = Value
        End Set
    End Property
    Private m_SelectedObject As IList(Of transactions_v01)

#Region "Statistik"
    Dim v_stat_min As Decimal = 0D
    Dim v_stat_max As Decimal = 0D
    Dim v_stat_sum As Decimal = 0D
    Dim v_stat_avg As Decimal = 0D
    Dim v_stat_stddev As Decimal = 0D
    Dim v_stat_count As Integer = 0


    <NotMapped>
    Public Property Stat_Min As Decimal
        Get
            Return v_stat_min
        End Get
        Set(value As Decimal)
            If v_stat_min <> value Then
                v_stat_min = value
                NotifyPropertyChanged("Stat_Min")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property Stat_Max As Decimal
        Get
            Return v_stat_max
        End Get
        Set(value As Decimal)
            If v_stat_max <> value Then
                v_stat_max = value
                NotifyPropertyChanged("Stat_Max")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property Stat_Sum As Decimal
        Get
            Return v_stat_sum
        End Get
        Set(value As Decimal)
            If v_stat_sum <> value Then
                v_stat_sum = value
                NotifyPropertyChanged("Stat_Sum")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property Stat_Avg As Decimal
        Get
            Return Decimal.Round(v_stat_avg, 2)
        End Get
        Set(value As Decimal)
            If v_stat_avg <> value Then
                v_stat_avg = value
                NotifyPropertyChanged("Stat_Avg")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property Stat_StdDev As Decimal
        Get
            Return Decimal.Round(v_stat_stddev, 2)
        End Get
        Set(value As Decimal)
            If v_stat_stddev <> value Then
                v_stat_stddev = value
                NotifyPropertyChanged("Stat_StdDev")
            End If
        End Set
    End Property

    <NotMapped>
    Public Property Stat_Count As Integer
        Get
            Return v_stat_count
        End Get
        Set(value As Integer)
            If v_stat_count <> value Then
                v_stat_count = value
                NotifyPropertyChanged("Stat_Count")
            End If
        End Set
    End Property

    Public ReadOnly Property search_bezeichnung_gal As String
        Get
            If search_bezeichnung.Length > 10 Then
                Return search_bezeichnung.Substring(0, 10)
            Else
                Return search_bezeichnung
            End If
        End Get
    End Property
#End Region

#End Region

End Class
