﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Text
Imports System.Collections.Specialized

Public Class transactions_repeat_v01
    Inherits model_base
    Implements INotifyCollectionChanged

    'Interne Variablen
    Dim v_trans_rep_id As Integer
    Dim v_comment As String
    Dim v_datum As Date = Date.Now
    Dim v_konto_id As Integer
    Dim v_to_konto_id As Nullable(Of Integer)
    Dim v_transtyp_id As Integer
    Dim v_transstatus_id As Nullable(Of Integer)
    Dim v_receiver_id As Nullable(Of Integer)
    Dim v_person_id As Nullable(Of Integer)

    Dim v_rep_timeframe_id As Integer
    Dim v_rep_timeframe_userdef As Integer = 1
    Dim v_rep_max_count As Integer = 1
    Dim v_rep_act_count As Integer = 0
    Dim v_rep_count_infinite As Boolean = True
    Dim v_faelligkeit As Date = Date.Now
    Dim v_auto_book As Boolean = True
    Dim v_user_confirm As Boolean = False



    Sub New()
        _Collections = New INotifyCollectionChanged() {categories_amount, tags}
        'CollectionChanged Eventu zu den Collections hinzufügen
        _Collections.ForEach(Sub(c) AddHandler c.CollectionChanged, AddressOf Collection_CollectionChanged)
    End Sub

    Public Sub Collection_CollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs)
        'Wenn eine der Navigation Properties geändert wird die in Frage kommenden Sonderproperties notifien
        NotifyPropertyChanged("real_totamount")
        NotifyPropertyChanged("neutral_totamount")
        NotifyPropertyChanged("real_totamount_str")
        NotifyPropertyChanged("neutral_totamount_str")
        NotifyPropertyChanged("list_categories")
        NotifyPropertyChanged("single_category_marker")
        Debug.Print("notify collection changed")
    End Sub


#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "datum"
                    If datum = Nothing Then result = "Datum darf nicht leer sein"
                Case "konto_id"
                    If konto_id = Nothing Then result = "Konto darf nicht leer sein"
                Case "to_konto_id"
                    If Not transtyp Is Nothing Then
                        If transtyp.internal_name = "transfer" Then
                            'Bei einer Transferbuchung muss das Zielkonto definiert sein:
                            If to_konto_id Is Nothing Then result = "Bei einer Transferbuchung muss ein Zielkonto angegeben werden"
                        End If
                    End If
                Case "transtyp_id"
                    If transtyp_id = Nothing Then result = "Typ darf nicht leer sein"
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If
            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region

#Region "Mapped"
    <Key>
    Public Property trans_rep_id As Integer
        Get
            Return v_trans_rep_id
        End Get
        Set(value As Integer)
            If v_trans_rep_id <> value Then
                v_trans_rep_id = value
                NotifyPropertyChanged("trans_rep_id")
            End If
        End Set
    End Property

    Public Property comment As String
        Get
            Return v_comment
        End Get
        Set(value As String)
            If v_comment <> value Then
                v_comment = value
                NotifyPropertyChanged("comment")
                NotifyPropertyChanged("short_comment")
            End If
        End Set
    End Property

    Public Property datum As Date
        Get
            Return v_datum
        End Get
        Set(value As Date)
            If v_datum <> value Then
                v_datum = value
                NotifyPropertyChanged("datum")
            End If
        End Set
    End Property

    Public Property faelligkeit As Date
        Get
            Return v_faelligkeit
        End Get
        Set(value As Date)
            If v_faelligkeit <> value Then
                v_faelligkeit = value
                NotifyPropertyChanged("faelligkeit")
            End If
        End Set
    End Property

    Public Property auto_book As Boolean
        Get
            Return v_auto_book
        End Get
        Set(value As Boolean)
            If v_auto_book <> value Then
                v_auto_book = value
                NotifyPropertyChanged("auto_book")
            End If
        End Set
    End Property

    Public Property user_confirm As Boolean
        Get
            Return v_user_confirm
        End Get
        Set(value As Boolean)
            If v_user_confirm <> value Then
                v_user_confirm = value
                NotifyPropertyChanged("user_confirm")
            End If
        End Set
    End Property

    Public Property konto_id As Integer
        Get
            Return v_konto_id
        End Get
        Set(value As Integer)
            If v_konto_id <> value Then
                v_konto_id = value
                NotifyPropertyChanged("konto_id")
            End If
        End Set
    End Property

    Public Property to_konto_id As Nullable(Of Integer)
        Get
            Return v_to_konto_id
        End Get
        Set(value As Nullable(Of Integer))
            v_to_konto_id = value
            NotifyPropertyChanged("to_konto_id")
        End Set
    End Property
    Public Property transtyp_id As Integer
        Get
            Return v_transtyp_id
        End Get
        Set(value As Integer)
            If v_transtyp_id <> value Then
                v_transtyp_id = value
                NotifyPropertyChanged("transtyp_id")
            End If
        End Set
    End Property

    Public Property transstatus_id As Nullable(Of Integer)
        Get
            Return v_transstatus_id
        End Get
        Set(value As Nullable(Of Integer))
            If v_transstatus_id Is Nothing Or v_transstatus_id <> value Then
                If value = 0 Then
                    v_transstatus_id = Nothing
                Else
                    v_transstatus_id = value
                End If
                NotifyPropertyChanged("transstatus_id")
            End If
        End Set
    End Property

    Public Property receiver_id As Nullable(Of Integer)
        Get
            Return v_receiver_id
        End Get
        Set(value As Nullable(Of Integer))
            If v_receiver_id Is Nothing Or v_receiver_id <> value Then
                If value = 0 Then
                    v_receiver_id = Nothing
                Else
                    v_receiver_id = value
                End If
                NotifyPropertyChanged("receiver_id")
            End If
        End Set
    End Property

    Public Property person_id As Nullable(Of Integer)
        Get
            Return v_person_id
        End Get
        Set(value As Nullable(Of Integer))
            If v_person_id Is Nothing Or v_person_id <> value Then
                If value = 0 Then
                    v_person_id = Nothing
                Else
                    v_person_id = value
                End If
                NotifyPropertyChanged("person_id")
            End If
        End Set
    End Property

    Public Property rep_timeframe_id As Integer
        Get
            Return v_rep_timeframe_id
        End Get
        Set(value As Integer)
            If v_rep_timeframe_id <> value Then
                v_rep_timeframe_id = value
                NotifyPropertyChanged("rep_timeframe_id")
            End If
        End Set
    End Property
    Public Property rep_timeframe_userdef As Integer
        Get
            Return v_rep_timeframe_userdef
        End Get
        Set(value As Integer)
            If v_rep_timeframe_userdef <> value Then
                v_rep_timeframe_userdef = value
                NotifyPropertyChanged("rep_timeframe_userdef")
            End If
        End Set
    End Property
    Public Property rep_max_count As Integer
        Get
            Return v_rep_max_count
        End Get
        Set(value As Integer)
            If v_rep_max_count <> value Then
                v_rep_max_count = value
                NotifyPropertyChanged("rep_max_count")
            End If
        End Set
    End Property

    Public Property rep_act_count As Integer
        Get
            Return v_rep_act_count
        End Get
        Set(value As Integer)
            If v_rep_act_count <> value Then
                v_rep_act_count = value
                NotifyPropertyChanged("rep_act_count")
            End If
        End Set
    End Property
    Public Property rep_count_infinite As Boolean
        Get
            Return v_rep_count_infinite
        End Get
        Set(value As Boolean)
            If v_rep_count_infinite <> value Then
                v_rep_count_infinite = value
                NotifyPropertyChanged("rep_count_infinite")
            End If
        End Set
    End Property
#End Region

#Region "Navigation Properties"

    Dim v_nv_konto As konto_v01
    Dim v_nv_to_konto As konto_v01
    Dim v_transtyp As trans_typ_v01
    Dim v_status As trans_status_v01
    Dim v_receiver As receiver_v01
    Dim v_person As person_v01

    <ForeignKey("konto_id")>
    Public Property nv_konto As konto_v01
        Get
            Return v_nv_konto
        End Get
        Set(value As konto_v01)
            If v_nv_konto IsNot value Then
                v_nv_konto = value
                NotifyPropertyChanged("nv_konto")
            End If
        End Set
    End Property
    <ForeignKey("to_konto_id")>
    Public Property nv_to_konto As konto_v01
        Get
            Return v_nv_to_konto
        End Get
        Set(value As konto_v01)
            If v_nv_to_konto IsNot value Then
                v_nv_to_konto = value
                NotifyPropertyChanged("nv_to_konto")
            End If
        End Set
    End Property
    <ForeignKey("transstatus_id")>
    Public Property status As trans_status_v01
        Get
            Return v_status
        End Get
        Set(value As trans_status_v01)
            If v_status IsNot value Then
                v_status = value
                NotifyPropertyChanged("status")
            End If
        End Set
    End Property
    <ForeignKey("receiver_id")>
    Public Property receiver As receiver_v01
        Get
            Return v_receiver
        End Get
        Set(value As receiver_v01)
            If v_receiver IsNot value Then
                v_receiver = value
                NotifyPropertyChanged("receiver")
            End If
        End Set
    End Property
    <ForeignKey("transtyp_id")>
    Public Property transtyp As trans_typ_v01
        Get
            Return v_transtyp
        End Get
        Set(value As trans_typ_v01)
            If v_transtyp IsNot value Then
                v_transtyp = value
                NotifyPropertyChanged("transtyp")
            End If
        End Set
    End Property
    <ForeignKey("person_id")>
    Public Property person As person_v01
        Get
            Return v_person
        End Get
        Set(value As person_v01)
            If v_person IsNot value Then
                v_person = value
                NotifyPropertyChanged("person")
            End If
        End Set
    End Property

    'It makes no sense to add a document to a repeat transaction
    'Public Overridable Property documents As New ObservableCollection(Of documents_v01)
    Public Overridable Property categories_amount As New ObservableCollection(Of transrep_2_kat)
    Public Overridable Property tags As New ObservableCollection(Of transrep_tag_v01)
#End Region

#Region "Extension"

    <NotMapped>
    Public Property Kategorien As ListCollectionView = New ListCollectionView(categories_amount)
#Region "Special Properties"

    ''' <summary>
    ''' Property gibt den mathematisch korrekten Wert einer Buchung an
    ''' Es ist definiert wie folgt:
    ''' Eingang = +
    ''' Ausgang = -
    ''' Transfer = 0
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property real_totamount As Decimal
        Get
            If transtyp Is Nothing Then Return 0
            'durch den Multiplikator ist ein Select Case nicht mehr notwendig:
            Return neutral_totamount * transtyp.multiplier
        End Get
    End Property

    Public ReadOnly Property real_totamount_str As String
        Get
            Return FormatCurrency(real_totamount, 2,,, TriState.True)
        End Get
    End Property

    Public ReadOnly Property neutral_totamount As Decimal
        Get
            Return categories_amount.Sum(Function(p) p.amount)
        End Get
    End Property

    Public ReadOnly Property neutral_totamount_str As String
        Get
            Return FormatCurrency(neutral_totamount, 2,,, TriState.True)
        End Get
    End Property

    ''' <summary>
    ''' This property returns the total amount with plus or minus or neutral depending on the type of transaction
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property neutral_state_totamount As Decimal
        Get
            Select Case transtyp.multiplier
                Case 1
                    Return neutral_totamount
                Case -1
                    Return neutral_totamount * transtyp.multiplier
                Case 0
                    Return neutral_totamount
                Case Else
                    Return Nothing
            End Select
        End Get
    End Property


    Public ReadOnly Property short_comment As String
        Get
            If comment = "" Then
                Return ""
            Else
                'Nach 40 Zeichen den String abschneiden:
                'Remove Line Feeds
                Dim v_temp As String = comment.Replace(Environment.NewLine, " ")
                If v_temp.Length < 40 Then
                    Return v_temp
                Else
                    Return v_temp.Substring(0, 39) & "..."
                End If
            End If
        End Get
    End Property

    ''' <summary>
    ''' Summarizes the used Categories to an String for displaying in Datagrid
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property list_categories As String
        Get
            If categories_amount.Count = 0 Then
                Return ""
            Else
                Dim v_cats As New StringBuilder
                For Each v_item As transrep_2_kat In categories_amount
                    If Not v_item.category Is Nothing Then
                        v_cats.AppendLine(v_item.category.bezeichnung)
                    End If
                Next
                Return v_cats.ToString
            End If
        End Get
    End Property

    Public ReadOnly Property single_category_marker As String
        Get
            If categories_amount.Count = 0 Then
                Return ""
            ElseIf categories_amount.Count = 1 Then
                Dim v_t2k As transrep_2_kat = DirectCast(categories_amount.First, transrep_2_kat)
                If v_t2k.category Is Nothing Then
                    Return String.Empty
                Else
                    Return v_t2k.category.fullname
                End If
            Else
                Return "Mehrfach - " & categories_amount.Count.ToString()
            End If
        End Get
    End Property

#End Region
#End Region

End Class
