﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.Text

Public Class transactions_template_v01
    Inherits model_base

    'Interne Variablen
    Dim v_transtemp_id As Integer
    Dim v_totamount As Decimal = 0D
    Dim v_comment As String
    Dim v_bezeichnung As String
    Dim v_color As String = "#000000"
    Dim v_symbol As Byte()
    Dim v_konto_id As Integer
    Dim v_to_konto_id As Nullable(Of Integer)
    Dim v_transstatus_id As Nullable(Of Integer)
    Dim v_receiver_id As Nullable(Of Integer)
    Dim v_person_id As Nullable(Of Integer)
    Dim v_transtyp_id As Integer


    Sub New()
        _Collections = New INotifyCollectionChanged() {nv_transtemp_2_kat, nv_transtemp_2_tag}
        _Collections.ForEach(Sub(c) AddHandler c.CollectionChanged, AddressOf Collection_CollectionChanged)
    End Sub

    Public Sub Collection_CollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs)
        'Wenn eine der Navigation Properties geändert wird die in Frage kommenden Sonderproperties notifien
        NotifyPropertyChanged("real_totamount")
        NotifyPropertyChanged("neutral_totamount")
        NotifyPropertyChanged("real_totamount_str")
        NotifyPropertyChanged("neutral_totamount_str")
        NotifyPropertyChanged("list_categories")
        NotifyPropertyChanged("single_category_marker")
        Debug.Print("notify collection changed")
    End Sub

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "bezeichnung"
                    If String.IsNullOrEmpty(bezeichnung) Then result = "Bezeichnung darf nicht leer sein"
                Case "konto_id"
                    If konto_id = Nothing Then result = "Konto darf nicht leer sein"
                Case "to_konto_id"
                    If Not nv_transtyp_2_transtemp_back Is Nothing Then
                        If nv_transtyp_2_transtemp_back.internal_name = "transfer" Then
                            'Bei einer Transferbuchung muss das Zielkonto definiert sein:
                            If to_konto_id Is Nothing Then result = "Bei einer Transferbuchung muss ein Zielkonto angegeben werden"
                        End If
                    End If
                Case "transtyp_id"
                    If transtyp_id = Nothing Then result = "Typ darf nicht leer sein"
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If
            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region

#Region "Mapped"
    <Key>
    Public Property transtemp_id As Integer
        Get
            Return v_transtemp_id
        End Get
        Set(value As Integer)
            If v_transtemp_id <> value Then
                v_transtemp_id = value
                NotifyPropertyChanged("transtemp_id")
            End If
        End Set
    End Property

    Public Property totamount As Decimal
        Get
            Return v_totamount
        End Get
        Set(value As Decimal)
            If v_totamount <> value Then
                v_totamount = value
                NotifyPropertyChanged("totamount")
            End If
        End Set
    End Property

    Public Property comment As String
        Get
            Return v_comment
        End Get
        Set(value As String)
            If v_comment <> value Then
                v_comment = value
                NotifyPropertyChanged("comment")
            End If
        End Set
    End Property

    Public Property bezeichnung As String
        Get
            Return v_bezeichnung
        End Get
        Set(value As String)
            If v_bezeichnung <> value Then
                v_bezeichnung = value
                NotifyPropertyChanged("bezeichnung")
                NotifyPropertyChanged("bezeichnung_gal")
            End If
        End Set
    End Property

    Public Property color As String
        Get
            Return v_color
        End Get
        Set(value As String)
            If v_color <> value Then
                v_color = value
                NotifyPropertyChanged("color")
            End If
        End Set
    End Property

    <MaxLength>
    Public Property symbol As Byte()
        Get
            Return v_symbol
        End Get
        Set(value As Byte())
            If v_symbol IsNot value Then
                v_symbol = value
                NotifyPropertyChanged("symbol")
                NotifyPropertyChanged("symbol_ever")
            End If
        End Set
    End Property

    Public Property konto_id As Integer
        Get
            Return v_konto_id
        End Get
        Set(value As Integer)
            If v_konto_id <> value Then
                v_konto_id = value
                NotifyPropertyChanged("konto_id")
            End If
        End Set
    End Property

    Public Property to_konto_id As Nullable(Of Integer)
        Get
            Return v_to_konto_id
        End Get
        Set(value As Nullable(Of Integer))
            v_to_konto_id = value
            NotifyPropertyChanged("to_konto_id")
        End Set
    End Property
    Public Property transtyp_id As Integer
        Get
            Return v_transtyp_id
        End Get
        Set(value As Integer)
            If v_transtyp_id <> value Then
                v_transtyp_id = value
                NotifyPropertyChanged("transtyp_id")
            End If
        End Set
    End Property

    Public Property transstatus_id As Nullable(Of Integer)
        Get
            Return v_transstatus_id
        End Get
        Set(value As Nullable(Of Integer))
            If v_transstatus_id Is Nothing Or v_transstatus_id <> value Then
                If value = 0 Then
                    v_transstatus_id = Nothing
                Else
                    v_transstatus_id = value
                End If
                NotifyPropertyChanged("transstatus_id")
            End If
        End Set
    End Property

    Public Property receiver_id As Nullable(Of Integer)
        Get
            Return v_receiver_id
        End Get
        Set(value As Nullable(Of Integer))
            If v_receiver_id Is Nothing Or v_receiver_id <> value Then
                If value = 0 Then
                    v_receiver_id = Nothing
                Else
                    v_receiver_id = value
                End If
                NotifyPropertyChanged("receiver_id")
            End If
        End Set
    End Property

    Public Property person_id As Nullable(Of Integer)
        Get
            Return v_person_id
        End Get
        Set(value As Nullable(Of Integer))
            If v_person_id Is Nothing Or v_person_id <> value Then
                If value = 0 Then
                    v_person_id = Nothing
                Else
                    v_person_id = value
                End If
                NotifyPropertyChanged("person_id")
            End If
        End Set
    End Property

#End Region


#Region "Navigation Properties"


    Dim v_nv_kto_2_transtemp_back As konto_v01
    Dim v_nv_kto_2_transtemp_transfer_back As konto_v01
    Dim v_nv_transstatus_2_transtemp_back As trans_status_v01
    Dim v_nv_receiver_2_transtemp_back As receiver_v01
    Dim v_nv_person_2_transtemp_back As person_v01
    Dim v_nv_transtyp_2_transtemp_back As trans_typ_v01

    Public Overridable Property nv_transtemp_2_kat As New ObservableCollection(Of transtemp_2_kat)
    Public Overridable Property nv_transtemp_2_tag As New ObservableCollection(Of transtemp_tag_v01)

    <ForeignKey("konto_id")>
    Public Property nv_kto_2_transtemp_back As konto_v01
        Get
            Return v_nv_kto_2_transtemp_back
        End Get
        Set(value As konto_v01)
            If v_nv_kto_2_transtemp_back IsNot value Then
                v_nv_kto_2_transtemp_back = value
                NotifyPropertyChanged("nv_kto_2_transtemp_back")
            End If
        End Set
    End Property
    <ForeignKey("to_konto_id")>
    Public Property nv_kto_2_transtemp_transfer_back As konto_v01
        Get
            Return v_nv_kto_2_transtemp_transfer_back
        End Get
        Set(value As konto_v01)
            If v_nv_kto_2_transtemp_transfer_back IsNot value Then
                v_nv_kto_2_transtemp_transfer_back = value
                NotifyPropertyChanged("nv_kto_2_transtemp_transfer_back")
            End If
        End Set
    End Property
    <ForeignKey("transstatus_id")>
    Public Property nv_transstatus_2_transtemp_back As trans_status_v01
        Get
            Return v_nv_transstatus_2_transtemp_back
        End Get
        Set(value As trans_status_v01)
            If v_nv_transstatus_2_transtemp_back IsNot value Then
                v_nv_transstatus_2_transtemp_back = value
                NotifyPropertyChanged("nv_transstatus_2_transtemp_back")
            End If
        End Set
    End Property
    <ForeignKey("receiver_id")>
    Public Property nv_receiver_2_transtemp_back As receiver_v01
        Get
            Return v_nv_receiver_2_transtemp_back
        End Get
        Set(value As receiver_v01)
            If v_nv_receiver_2_transtemp_back IsNot value Then
                v_nv_receiver_2_transtemp_back = value
                NotifyPropertyChanged("nv_receiver_2_transtemp_back")
            End If
        End Set
    End Property
    <ForeignKey("person_id")>
    Public Property nv_person_2_transtemp_back As person_v01
        Get
            Return v_nv_person_2_transtemp_back
        End Get
        Set(value As person_v01)
            If v_nv_person_2_transtemp_back IsNot value Then
                v_nv_person_2_transtemp_back = value
                NotifyPropertyChanged("nv_person_2_transtemp_back")
            End If
        End Set
    End Property
    <ForeignKey("transtyp_id")>
    Public Property nv_transtyp_2_transtemp_back As trans_typ_v01
        Get
            Return v_nv_transtyp_2_transtemp_back
        End Get
        Set(value As trans_typ_v01)
            If v_nv_transtyp_2_transtemp_back IsNot value Then
                v_nv_transtyp_2_transtemp_back = value
                NotifyPropertyChanged("nv_transtyp_2_transtemp_back")
            End If
        End Set
    End Property
#End Region

#Region "Extension"

    <NotMapped>
    Public Property Kategorien As ListCollectionView = New ListCollectionView(nv_transtemp_2_kat)

    Public ReadOnly Property solid_color() As SolidColorBrush
        Get
            If color Is Nothing Then
                Return ColorBrushFromResources("IdealForegroundColorBrush")
            Else
                Try
                    Dim v_col As System.Drawing.Color = System.Drawing.ColorTranslator.FromHtml(color)
                    Dim v_color As Color = System.Windows.Media.Color.FromArgb(v_col.A, v_col.R, v_col.G, v_col.B)
                    Return New SolidColorBrush(v_color)
                Catch ex As Exception
                    Return ColorBrushFromResources("IdealForegroundColorBrush")
                End Try
            End If
        End Get
    End Property

    ''' <summary>
    ''' Text für den Ribbon Tooltip
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property ToolTipRibbon() As String
        Get
            Dim v_text As String = ""
            v_text = "Typ: " & nv_transtyp_2_transtemp_back.bezeichnung & Environment.NewLine
            v_text &= "für Konto: " & nv_kto_2_transtemp_back.bezeichnung & Environment.NewLine
            v_text &= "Betrag: " & String.Format("{0:C}", totamount) & Environment.NewLine
            v_text &= "Bemerkung:" & Environment.NewLine
            v_text &= comment
            Return v_text
        End Get
    End Property

    Public ReadOnly Property symbol_ever() As Byte()
        Get
            If symbol Is Nothing Then
                Return ResourceDictionaryImagetoByte("TransTemplate")
            Else
                Return symbol
            End If
        End Get
    End Property

#Region "Special Properties"

    ''' <summary>
    ''' Property gibt den mathematisch korrekten Wert einer Buchung an
    ''' Es ist definiert wie folgt:
    ''' Eingang = +
    ''' Ausgang = -
    ''' Transfer = 0
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property real_totamount As Decimal
        Get
            If v_nv_transtyp_2_transtemp_back Is Nothing Then Return 0
            'durch den Multiplikator ist ein Select Case nicht mehr notwendig:
            Return neutral_totamount * v_nv_transtyp_2_transtemp_back.multiplier
        End Get
    End Property

    Public ReadOnly Property real_totamount_str As String
        Get
            Return FormatCurrency(real_totamount, 2,,, TriState.True)
        End Get
    End Property

    Public ReadOnly Property neutral_totamount As Decimal
        Get
            Return nv_transtemp_2_kat.Sum(Function(p) p.amount)
        End Get
    End Property

    Public ReadOnly Property neutral_totamount_str As String
        Get
            Return FormatCurrency(neutral_totamount, 2,,, TriState.True)
        End Get
    End Property

    Public ReadOnly Property short_comment As String
        Get
            If comment = "" Then
                Return ""
            Else
                'Nach 40 Zeichen den String abschneiden:
                'Remove Line Feeds
                Dim v_temp As String = comment.Replace(Environment.NewLine, " ")
                If v_temp.Length < 40 Then
                    Return v_temp
                Else
                    Return v_temp.Substring(0, 39) & "..."
                End If
            End If
        End Get
    End Property

    ''' <summary>
    ''' Summarizes the used Categories to an String for displaying in Datagrid
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property list_categories As String
        Get
            If nv_transtemp_2_kat.Count = 0 Then
                Return ""
            Else
                Dim v_cats As New StringBuilder
                For Each v_item As transtemp_2_kat In nv_transtemp_2_kat
                    If Not v_item.nv_cat_2_transtemp_back Is Nothing Then
                        v_cats.AppendLine(v_item.nv_cat_2_transtemp_back.bezeichnung)
                    End If
                Next
                Return v_cats.ToString
            End If
        End Get
    End Property

    Public ReadOnly Property single_category_marker As String
        Get
            If nv_transtemp_2_kat.Count = 0 Then
                Return ""
            ElseIf nv_transtemp_2_kat.Count = 1 Then
                Dim v_t2k As transtemp_2_kat = DirectCast(nv_transtemp_2_kat.First, transtemp_2_kat)
                If v_t2k.nv_cat_2_transtemp_back Is Nothing Then
                    Return String.Empty
                Else
                    Return v_t2k.nv_cat_2_transtemp_back.fullname
                End If
            Else
                Return "Mehrfach - " & nv_transtemp_2_kat.Count.ToString()
            End If
        End Get
    End Property

    Public ReadOnly Property bezeichnung_gal As String
        Get
            If bezeichnung.Length > 10 Then
                Return bezeichnung.Substring(0, 10)
            Else
                Return bezeichnung
            End If
        End Get
    End Property

#End Region
#End Region

End Class
