﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Data.Entity
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Categories:

        Private WithEvents __categories As New ObservableCollection(Of category_v01)
        ''' <summary>
        ''' Alle Transaktionstypen
        ''' </summary>
        ''' <returns></returns>
        Public Property Categories As ListCollectionView
        Public Property Categories_MainCats_All As ListCollectionView
        Public Property Categories_MainCats_Aktiv As ListCollectionView
        Public Property Categories_Aktiv As ListCollectionView

        Private Sub CategoriesLoad()
            __categories.Clear()
            dbo.m_category_v01.Load
            __categories = dbo.m_category_v01.Local
            Categories = New ListCollectionView(__categories)
            Categories_MainCats_All = New ListCollectionView(__categories) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.MainCatsAll)
            }
            Categories_MainCats_Aktiv = New ListCollectionView(__categories) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.MainCatsAktiv)
            }
            Categories_Aktiv = New ListCollectionView(__categories) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.CatsAktiv)
            }
            Categories_Aktiv.SortDescriptions.Clear()
            Categories_Aktiv.SortDescriptions.Add(New SortDescription("fullname", ListSortDirection.Ascending))
        End Sub

        Private Sub __categories_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __categories.CollectionChanged
            'If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not Categories Is Nothing Then
                If Not Categories.MoveCurrentToNext Then Categories.MoveCurrentToPrevious()
                Categories.SortDescriptions.Clear()
                Categories.SortDescriptions.Add(New SortDescription("fullname", ListSortDirection.Ascending))
            End If
            If Not Categories_MainCats_All Is Nothing Then
                If Not Categories_MainCats_All.MoveCurrentToNext Then Categories_MainCats_All.MoveCurrentToPrevious()
                If Not Categories_MainCats_All.IsAddingNew Or Categories_MainCats_All.IsEditingItem Then Categories_MainCats_All.Filter = New Predicate(Of Object)(AddressOf Filters.MainCatsAll)
            End If
            If Not Categories_MainCats_Aktiv Is Nothing Then
                If Not Categories_MainCats_Aktiv.MoveCurrentToNext Then Categories_MainCats_Aktiv.MoveCurrentToPrevious()
                If Not Categories_MainCats_Aktiv.IsAddingNew Or Categories_MainCats_Aktiv.IsEditingItem Then Categories_MainCats_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.MainCatsAktiv)
            End If
            If Not Categories_Aktiv Is Nothing Then
                If Not Categories_Aktiv.MoveCurrentToNext Then Categories_Aktiv.MoveCurrentToPrevious()
                If Not Categories_Aktiv.IsAddingNew Or Categories_Aktiv.IsEditingItem Then Categories_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.CatsAktiv)
                Categories_Aktiv.SortDescriptions.Clear()
                Categories_Aktiv.SortDescriptions.Add(New SortDescription("fullname", ListSortDirection.Ascending))
            End If
        End Sub

#Region "Commands"

        Public Property cmdCategoryMainAdd As New RelayCommand(AddressOf CategoryMainAdd)
        Public Property cmdCategorySubAdd As New RelayCommand(Of category_v01)(Sub(p) CategorySubAdd(p), Function(p) p IsNot Nothing)

        Public Property cmdCategoryImage As New RelayCommand(Of category_v01)(Sub(p) CategoryImage(p), Function(p) p IsNot Nothing)
        Public Property cmdCategoryDelete As New RelayCommand(Of category_v01)(Sub(p) CategoryDelete(p), Function(p) CategoryCanDelete(p))

        Private Sub CategoryMainAdd()
            Debug.Print(Categories_MainCats_All.Count.ToString)
            __categories.Add(New category_v01 With {.aktiv = True, .bezeichnung = "<Neue Kategorie>"})
            'If Not Categories_MainCats_All.IsAddingNew Or Categories_MainCats_All.IsEditingItem Then Categories_MainCats_All.Filter = New Predicate(Of Object)(AddressOf Filters.MainCatsAll)
            __categories_CollectionChanged(Me, Nothing)
            Debug.Print(Categories_MainCats_All.Count.ToString)
        End Sub

        Private Sub CategorySubAdd(v_maincat As category_v01)
            If v_maincat Is Nothing Then Exit Sub
            v_maincat.nv_subcats.Add(New category_v01 With {.bezeichnung = "<Neue Unterkategorie>", .parent_cat_id = v_maincat.cat_id})
            __categories_CollectionChanged(Me, Nothing)
            dbo.SaveChanges()
        End Sub

        Private Sub CategoryImage(v_cat As category_v01)
            If v_cat Is Nothing Then Exit Sub
            Dim v_image As Byte() = get_symbol_from_dialog()
            If v_image IsNot Nothing Then
                v_cat.symbol = v_image
            End If
        End Sub

        Private Async Sub CategoryDelete(v_cat As category_v01)
            If v_cat Is Nothing Then Exit Sub
            'the test if a delete is possible is done:
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_mainwindow As MahApps.Metro.Controls.MetroWindow = DirectCast(Application.Current.MainWindow, MahApps.Metro.Controls.MetroWindow)
            Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Frage", String.Format("Soll die Kategorie {0} wirklich gelöscht werden?", v_cat.bezeichnung), MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                __categories.Remove(v_cat)
                dbo.SaveChanges()
            End If
        End Sub

        Private Function CategoryCanDelete(v_cat As category_v01) As Boolean
            If v_cat Is Nothing Then Return False
            With v_cat
                If .nv_category_2_budcat.Count > 0 Then Return False
                If .nv_cat_2_transtemp.Count > 0 Then Return False
                If .nv_cat_trans2kat.Count > 0 Then Return False
                If .nv_subcats.Count > 0 Then Return False
            End With
            Return True
        End Function
#End Region

    End Class
End Namespace

