﻿Imports System.Threading
Imports System.Windows.Threading
Imports LiveCharts
Imports LiveCharts.Wpf

Namespace HHHB3.ViewModel


    Partial Public Class MainViewModel
        'Partial Entität for charting

        Private Sub ChartsLoadAndUpdate()
            Dim thr_start As ThreadStart = Sub()
                                               Application.Current.Dispatcher.Invoke(DispatcherPriority.Background, New Action(Sub()
                                                                                                                                   ChartsLoadAndUpdateDo()
                                                                                                                               End Sub))
                                           End Sub
            Dim thr As New Thread(thr_start)
            thr.IsBackground = True
            thr.Name = "ChartsLoadAndUpdate"
            thr.Start()
        End Sub

        Private Sub ChartsLoadAndUpdateDo()
            For Each v_item As Object In Widgets
                Select Case True
                    Case TypeOf (v_item) Is cls_home_einaus
                        Chart_InOut_Updater(DirectCast(v_item, cls_home_einaus))
                    Case TypeOf (v_item) Is cls_home_topcats
                        Chart_TopCats_Updater(DirectCast(v_item, cls_home_topcats))
                    Case TypeOf (v_item) Is cls_home_cats
                        Chart_Cats_Updater(DirectCast(v_item, cls_home_cats))
                    Case TypeOf (v_item) Is cls_home_topreceivers
                        Chart_TopReceivers_Updater(DirectCast(v_item, cls_home_topreceivers))
                    Case TypeOf (v_item) Is cls_home_receivers
                        Chart_Receivers_Updater(DirectCast(v_item, cls_home_receivers))
                    Case TypeOf (v_item) Is cls_home_toppersons
                        Chart_TopPersons_Updater(DirectCast(v_item, cls_home_toppersons))
                    Case TypeOf (v_item) Is cls_home_persons
                        Chart_Persons_Updater(DirectCast(v_item, cls_home_persons))
                    Case TypeOf (v_item) Is cls_home_targetgauge
                        Chart_TargetGauge_Updater(DirectCast(v_item, cls_home_targetgauge))
                End Select
            Next
            Chart_Accounts_Updater()
        End Sub

#Region "In/Out Chart"

        Public Property cmdChart_InOut_Update As New RelayCommand(Of cls_home_einaus)(Sub(p) Chart_InOut_Updater(p), Function(p) p IsNot Nothing)
        Public Property cmdDashboardWidgetSettingsEinAus As New RelayCommand(Of cls_home_einaus)(Sub(p) DashboardWidgetSettingsEinAus(p), Function(p) p IsNot Nothing)

        Private Function Chart_InOut_Updater(v_einaus As cls_home_einaus) As Boolean
            If v_einaus Is Nothing Then Return False

            With v_einaus
                Try
                    .Chart_InOut_Series.Clear()
                Catch ex As Exception
                    Debug.Print("Chart Einaus Error:" & ex.Exception.ToString)
                    'Return False
                End Try

                Dim v_pos_column As New ColumnSeries
                Dim v_neg_column As New ColumnSeries
                Dim v_pos_chart_values As New ChartValues(Of Double)
                Dim v_neg_chart_values As New ChartValues(Of Double)
                Dim v_posvalues As Decimal = 0
                Dim v_negvalues As Decimal = 0

                If .Chart_InOut_EndDate < .Chart_InOut_StartDate Then Return False

                v_posvalues = __transactions.Where(Function(x) x.datum <= .Chart_InOut_EndDate AndAlso x.datum >= .Chart_InOut_StartDate AndAlso x.real_totamount > 0).Sum(Function(x) x.real_totamount)
                v_negvalues = __transactions.Where(Function(x) x.datum <= .Chart_InOut_EndDate AndAlso x.datum >= .Chart_InOut_StartDate AndAlso x.real_totamount < 0).Sum(Function(x) x.real_totamount)

                v_pos_chart_values.Add(v_posvalues)
                v_neg_chart_values.Add(v_negvalues)
                With v_pos_column
                    .Title = "Einnnahmen"
                    .Values = v_pos_chart_values
                End With
                With v_neg_column
                    .Title = "Ausgaben"
                    .Values = v_neg_chart_values
                End With
                .Chart_InOut_Series.Add(v_pos_column)
                .Chart_InOut_Series.Add(v_neg_column)
            End With
            Return True
        End Function

        Private Sub DashboardWidgetSettingsEinAus(v_einaus As cls_home_einaus)
            If v_einaus Is Nothing Then Exit Sub

            Dim v_dia As New ucl_home_einaus_settings

            With v_dia
                v_einaus.BeginEdit()
                .DataContext = v_einaus
                .ShowDialog()
                If .DialogResult Then
                    v_einaus.EndEdit()
                    Chart_InOut_Updater(v_einaus)
                    'The settings of the Widget should be saved to the database:
                    Dim v_widgetdb As widgets_v01 = __widgetsdb.Where(Function(x) x.Id = v_einaus.DBWidget.Id).FirstOrDefault
                    If v_widgetdb Is Nothing Then
                        cls_logger.v_logger.Error(String.Format("Widget mit ID {0} konnte nicht gefunden werden", v_einaus.DBWidget.Id))
                        MessageAdd(New message_v01 With {.header = "Fehler Widget Einstellungen", .iserrormsg = True, .message = "Einstellungen des Widgets Einnamen zu Ausgaben konnten nicht übernommen werden", .priority = 3, .stayalive = False})
                    Else
                        With v_widgetdb
                            .BeginEdit()
                            .para_date1 = v_einaus.Chart_InOut_StartDate
                            .para_date2 = v_einaus.Chart_InOut_EndDate
                            .EndEdit()
                        End With
                        dbo.SaveChanges()
                    End If
                Else
                    v_einaus.CancelEdit()
                End If
            End With
        End Sub
#End Region

#Region "Account Chart"
        Public Property Chart_Accounts_Series As SeriesCollection = New SeriesCollection
        Public Property Chart_Accounts_Labels As New List(Of String)
        Public Property Chart_Accounts_Formatter As Func(Of Double, String) = Function(value) value.ToString("N")
        Public Property cmdChart_Accounts_Update As New RelayCommand(AddressOf Chart_Accounts_Updater)

        'Values for the positive and negative value section widths:
        Dim v_chart_accounts_sectionposvalue As Double = 0
        Dim v_chart_accounts_sectionnegvalue As Double = 0

        Public Property Chart_Accounts_SectionPosValue As Double
            Get
                Return v_chart_accounts_sectionposvalue
            End Get
            Set(value As Double)
                If v_chart_accounts_sectionposvalue <> value Then
                    v_chart_accounts_sectionposvalue = value
                    RaisePropertyChanged("Chart_Accounts_SectionPosValue")
                End If
            End Set
        End Property
        Public Property Chart_Accounts_SectionNegValue As Double
            Get
                Return v_chart_accounts_sectionnegvalue
            End Get
            Set(value As Double)
                If v_chart_accounts_sectionnegvalue <> value Then
                    v_chart_accounts_sectionnegvalue = value
                    RaisePropertyChanged("Chart_Accounts_SectionNegValue")
                End If
            End Set
        End Property


        Private Function Chart_Accounts_Updater() As Boolean
            Try
                Chart_Accounts_Series.Clear()
            Catch ex As Exception
                Debug.Print("Chart Konto Error:" & ex.Exception.ToString)
                'Return False
            End Try

            Chart_Accounts_Labels.Clear()

            Dim v_column As New RowSeries With {.Title = "Konto Wert"}
            Dim v_values As New ChartValues(Of Double)

            If Not Konten_Home Is Nothing Then
                For Each v_konto As konto_v01 In Konten_Home
                    Chart_Accounts_Labels.Add(v_konto.bezeichnung_full)
                    v_values.Add(v_konto.Totalamount)
                Next

                v_column.Values = v_values
                Chart_Accounts_Series.Add(v_column)

                Chart_Accounts_SectionPosValue = Math.Ceiling(v_values.Max)
                Chart_Accounts_SectionNegValue = Math.Ceiling(v_values.Min)


            End If
            Return True
        End Function
#End Region

#Region "Top Categories Chart"
        Public Property cmdChart_TopCats_Update As New RelayCommand(Of cls_home_topcats)(Sub(p) Chart_TopCats_Updater(p), Function(p) p IsNot Nothing)
        Public Property cmdDashboardWidgetSettingsTopCats As New RelayCommand(Of cls_home_topcats)(Sub(p) DashboardWidgetSettingsTopCats(p), Function(p) p IsNot Nothing)

        Private Function Chart_TopCats_Updater(v_widget As cls_home_topcats) As Boolean
            If v_widget Is Nothing Then Return False
            With v_widget
                Try
                    .Chart_TopCats_Series.Clear()
                Catch ex As Exception
                    Debug.Print("Chart TopCats Error:" & ex.Exception.ToString)
                    'Return False
                End Try

                .Chart_TopCats_Labels.Clear()

                Dim v_column As New ColumnSeries With {.Title = "Kategorien"}
                Dim v_values As New ChartValues(Of Double)
                Dim v_count As Integer = 1
                If Not Categories_Aktiv Is Nothing AndAlso Categories_Aktiv.Count > 0 Then
                    Dim v_cats_temp As ListCollectionView = New ListCollectionView(__categories) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.CatsAktiv)
            }
                    'Caluclate the timespan based totamount before sorting:
                    For Each v_item As category_v01 In v_cats_temp
                        v_item.totamount_timespan_caluclator(v_widget.DBWidget.para_date1, v_widget.DBWidget.para_date2)
                    Next
                    'Apply a filter to remove all 0 amounts:
                    If v_widget.DBWidget.para_bol1 = True Then
                        v_cats_temp.Filter = New Predicate(Of Object)(AddressOf Filters.TotAmountTimespanBiggerZero)
                    Else
                        v_cats_temp.Filter = New Predicate(Of Object)(AddressOf Filters.TotAmountTimespanSmallerZero)
                    End If

                    'Apply Sort:
                    v_cats_temp.SortDescriptions.Add(New ComponentModel.SortDescription With {.PropertyName = "totamount_timespan", .Direction = ComponentModel.ListSortDirection.Ascending})

                    For Each v_cat As category_v01 In v_cats_temp
                        If v_count <= v_widget.DBWidget.para_int1 Then
                            .Chart_TopCats_Labels.Add(v_cat.fullname)
                            v_values.Add(v_cat.totamount_timespan)
                            v_count += 1
                        Else
                            Exit For
                        End If
                    Next
                    v_column.Values = v_values
                    .Chart_TopCats_Series.Add(v_column)
                    v_cats_temp = Nothing
                End If
            End With

            Return True
        End Function

        Private Sub DashboardWidgetSettingsTopCats(v_topcats As cls_home_topcats)
            If v_topcats Is Nothing Then Exit Sub

            Dim v_dia As New ucl_home_topcats_settings

            With v_dia
                v_topcats.BeginEdit()
                .DataContext = v_topcats
                .ShowDialog()
                If .DialogResult Then
                    v_topcats.EndEdit()
                    Chart_TopCats_Updater(v_topcats)
                    'The settings of the Widget should be saved to the database:
                    Dim v_widgetdb As widgets_v01 = __widgetsdb.Where(Function(x) x.Id = v_topcats.DBWidget.Id).FirstOrDefault
                    If v_widgetdb Is Nothing Then
                        cls_logger.v_logger.Error(String.Format("Widget mit ID {0} konnte nicht gefunden werden", v_topcats.DBWidget.Id))
                        MessageAdd(New message_v01 With {.header = "Fehler Widget Einstellungen", .iserrormsg = True, .message = "Einstellungen des Widgets Top Kategorien konnten nicht übernommen werden", .priority = 3, .stayalive = False})
                    Else
                        With v_widgetdb
                            .BeginEdit()
                            .para_date1 = v_topcats.DBWidget.para_date1
                            .para_date2 = v_topcats.DBWidget.para_date2
                            .para_int1 = v_topcats.DBWidget.para_int1
                            .para_bol1 = v_topcats.DBWidget.para_bol1
                            .EndEdit()
                        End With
                        dbo.SaveChanges()
                    End If
                Else
                    v_topcats.CancelEdit()
                End If
            End With
        End Sub

#End Region

#Region "Categories Chart"
        Public Property cmdChart_Cats_Update As New RelayCommand(Of cls_home_cats)(Sub(p) Chart_Cats_Updater(p), Function(p) p IsNot Nothing)
        Public Property cmdDashboardWidgetSettingsCats As New RelayCommand(Of cls_home_cats)(Sub(p) DashboardWidgetSettingsCats(p), Function(p) p IsNot Nothing)

        Private Function Chart_Cats_Updater(v_widget As cls_home_cats) As Boolean
            If v_widget Is Nothing Then Return False
            With v_widget
                Try
                    .Chart_Cats_Series.Clear()
                Catch ex As Exception
                    Debug.Print("Chart Cats Error:" & ex.Exception.ToString)
                End Try

                .Chart_Cats_Labels.Clear()
                'Selected Categories are stored in para_str1 with delimiter ;
                Dim v_column As New RowSeries With {.Title = "Kategorien"}
                Dim v_values As New ChartValues(Of Double)

                If Not Categories_Aktiv Is Nothing AndAlso String.IsNullOrEmpty(v_widget.DBWidget.para_str1) = False Then
                    Dim v_selected_cats As New List(Of category_v01)
                    Dim v_sel_cats_ids As String() = v_widget.DBWidget.para_str1.Split(";")
                    For i As Integer = 0 To v_sel_cats_ids.Count - 1
                        Dim v_ci As Integer = i
                        If __categories.Where(Function(x) x.cat_id = CInt(v_sel_cats_ids(v_ci)) AndAlso CBool(x.aktiv) = True).FirstOrDefault IsNot Nothing Then
                            v_selected_cats.Add(__categories.Where(Function(x) x.cat_id = CInt(v_sel_cats_ids(v_ci)) AndAlso CBool(x.aktiv) = True).FirstOrDefault)
                        End If
                    Next
                    If v_selected_cats IsNot Nothing AndAlso v_selected_cats.Count > 0 Then
                        'Caluclate the timespan based totamount:
                        For Each v_item As category_v01 In v_selected_cats
                            v_item.totamount_timespan_caluclator(v_widget.DBWidget.para_date1, v_widget.DBWidget.para_date2)
                            .Chart_Cats_Labels.Add(v_item.fullname)
                            v_values.Add(v_item.totamount_timespan)
                        Next
                    End If
                    v_column.Values = v_values
                    .Chart_Cats_Series.Add(v_column)
                End If
            End With

            Return True
        End Function

        Private Sub DashboardWidgetSettingsCats(v_cats As cls_home_cats)
            If v_cats Is Nothing Then Exit Sub
            Dim v_dia As New ucl_home_cats_settings
            With v_dia
                v_cats.BeginEdit()
                .DataContext = v_cats
                .ShowDialog()
                If .DialogResult Then
                    v_cats.EndEdit()
                    Chart_Cats_Updater(v_cats)
                    'The settings of the Widget should be saved to the database:
                    Dim v_widgetdb As widgets_v01 = __widgetsdb.Where(Function(x) x.Id = v_cats.DBWidget.Id).FirstOrDefault
                    If v_widgetdb Is Nothing Then
                        cls_logger.v_logger.Error(String.Format("Widget mit ID {0} konnte nicht gefunden werden", v_cats.DBWidget.Id))
                        MessageAdd(New message_v01 With {.header = "Fehler Widget Einstellungen", .iserrormsg = True, .message = "Einstellungen des Widgets Kategorien konnten nicht übernommen werden", .priority = 3, .stayalive = False})
                    Else
                        With v_widgetdb
                            .BeginEdit()
                            .para_date1 = v_cats.DBWidget.para_date1
                            .para_date2 = v_cats.DBWidget.para_date2
                            .para_str1 = v_cats.DBWidget.para_str1
                            .EndEdit()
                        End With
                        dbo.SaveChanges()
                    End If
                Else
                    v_cats.CancelEdit()
                End If
            End With
        End Sub

#End Region

#Region "Target Gauge Chart"
        Public Property cmdChart_TargetGauge_Update As New RelayCommand(Of cls_home_targetgauge)(Sub(p) Chart_TargetGauge_Updater(p), Function(p) p IsNot Nothing)
        Public Property cmdDashboardWidgetSettingsTargetGauge As New RelayCommand(Of cls_home_targetgauge)(Sub(p) DashboardWidgetSettingsTargetGauge(p), Function(p) p IsNot Nothing)


        Private Function Chart_TargetGauge_Updater(v_widget As cls_home_targetgauge) As Boolean
            If v_widget Is Nothing Then Return False

            Dim v_definition As savingtargets_v01 = __savingtargets.Where(Function(x) x.Id = v_widget.DBWidget.para_int1).FirstOrDefault
            If v_definition Is Nothing Then Return False

            'Set the Values of the target to pass into the widget:
            v_widget.DBWidget.para_dec1 = v_definition.target_value
            'if the current_value is > than the target_value we have to set current_value to the max amount
            'this is only ok if we have a income gauge otherwise:
            If v_definition.track_income Then
                If v_definition.current_value > v_definition.target_value Then
                    v_widget.DBWidget.para_dec2 = v_definition.target_value
                Else
                    v_widget.DBWidget.para_dec2 = v_definition.current_value
                End If
            Else
                If v_definition.current_value < v_definition.target_value Then
                    v_widget.DBWidget.para_dec2 = v_definition.target_value
                Else
                    v_widget.DBWidget.para_dec2 = v_definition.current_value
                End If
            End If

            v_widget.DBWidget.para_dec3 = v_definition.current_value
            v_widget.DBWidget.para_str1 = v_definition.bezeichnung

            v_definition = Nothing
            Return True
        End Function


        Private Sub DashboardWidgetSettingsTargetGauge(v_targetgauge As cls_home_targetgauge)
            If v_targetgauge Is Nothing Then Exit Sub

            Dim v_dia As New ucl_home_targetgauge_settings

            With v_dia
                v_targetgauge.BeginEdit()
                .DataContext = v_targetgauge
                .ShowDialog()
                If .DialogResult Then
                    v_targetgauge.EndEdit()
                    'The settings of the Widget should be saved to the database:
                    Dim v_widgetdb As widgets_v01 = __widgetsdb.Where(Function(x) x.Id = v_targetgauge.DBWidget.Id).FirstOrDefault
                    If v_widgetdb Is Nothing Then
                        cls_logger.v_logger.Error(String.Format("Widget mit ID {0} konnte nicht gefunden werden", v_targetgauge.DBWidget.Id))
                        MessageAdd(New message_v01 With {.header = "Fehler Widget Einstellungen", .iserrormsg = True, .message = "Einstellungen des Widgets TargetGauge konnten nicht übernommen werden", .priority = 3, .stayalive = False})
                    Else
                        With v_widgetdb
                            .BeginEdit()
                            .para_date1 = v_targetgauge.DBWidget.para_date1
                            .para_date2 = v_targetgauge.DBWidget.para_date2
                            .para_int1 = v_targetgauge.DBWidget.para_int1
                            .EndEdit()
                        End With
                        dbo.SaveChanges()
                    End If
                Else
                    v_targetgauge.CancelEdit()
                End If
            End With
        End Sub
#End Region

#Region "Top Receiver Chart"
        Public Property cmdChart_TopReceivers_Update As New RelayCommand(Of cls_home_topreceivers)(Sub(p) Chart_TopReceivers_Updater(p), Function(p) p IsNot Nothing)
        Public Property cmdDashboardWidgetSettingsTopReceivers As New RelayCommand(Of cls_home_topreceivers)(Sub(p) DashboardWidgetSettingsTopReceivers(p), Function(p) p IsNot Nothing)

        Private Function Chart_TopReceivers_Updater(v_widget As cls_home_topreceivers) As Boolean
            If v_widget Is Nothing Then Return False
            With v_widget
                Try
                    .Chart_TopRecs_Series.Clear()
                Catch ex As Exception
                    Debug.Print("Chart TopRecs Error:" & ex.Exception.ToString)
                End Try

                .Chart_TopRecs_Labels.Clear()

                Dim v_column As New ColumnSeries With {.Title = "Empfänger"}
                Dim v_values As New ChartValues(Of Double)
                Dim v_count As Integer = 1
                If Not Receivers_Aktiv Is Nothing AndAlso Receivers_Aktiv.Count > 0 Then
                    Dim v_recs_temp As ListCollectionView = New ListCollectionView(__reveicer) With {.Filter = New Predicate(Of Object)(AddressOf Filters.ObjAktiv)}
                    'Caluclate the timespan based totamount before sorting:
                    For Each v_item As receiver_v01 In v_recs_temp
                        v_item.totamount_timespan_caluclator(v_widget.DBWidget.para_date1, v_widget.DBWidget.para_date2)
                    Next
                    'Apply a filter to remove all 0 amounts:
                    If v_widget.DBWidget.para_bol1 = True Then
                        v_recs_temp.Filter = New Predicate(Of Object)(AddressOf Filters.TotAmountTimespanBiggerZero)
                    Else
                        v_recs_temp.Filter = New Predicate(Of Object)(AddressOf Filters.TotAmountTimespanSmallerZero)
                    End If
                    'Apply Sort:
                    v_recs_temp.SortDescriptions.Add(New ComponentModel.SortDescription With {.PropertyName = "totamount_timespan", .Direction = ComponentModel.ListSortDirection.Ascending})

                    For Each v_rec As receiver_v01 In v_recs_temp
                        If v_count <= v_widget.DBWidget.para_int1 Then
                            .Chart_TopRecs_Labels.Add(v_rec.bezeichnung)
                            v_values.Add(v_rec.totamount_timespan)
                            v_count += 1
                        Else
                            Exit For
                        End If
                    Next
                    v_column.Values = v_values
                    .Chart_TopRecs_Series.Add(v_column)
                    v_recs_temp = Nothing
                End If
            End With

            Return True
        End Function

        Private Sub DashboardWidgetSettingsTopReceivers(v_toprecs As cls_home_topreceivers)
            If v_toprecs Is Nothing Then Exit Sub

            Dim v_dia As New ucl_home_topreceivers_settings

            With v_dia
                v_toprecs.BeginEdit()
                .DataContext = v_toprecs
                .ShowDialog()
                If .DialogResult Then
                    v_toprecs.EndEdit()
                    Chart_TopReceivers_Updater(v_toprecs)
                    'The settings of the Widget should be saved to the database:
                    Dim v_widgetdb As widgets_v01 = __widgetsdb.Where(Function(x) x.Id = v_toprecs.DBWidget.Id).FirstOrDefault
                    If v_widgetdb Is Nothing Then
                        cls_logger.v_logger.Error(String.Format("Widget mit ID {0} konnte nicht gefunden werden", v_toprecs.DBWidget.Id))
                        MessageAdd(New message_v01 With {.header = "Fehler Widget Einstellungen", .iserrormsg = True, .message = "Einstellungen des Widgets Top Receivers konnten nicht übernommen werden", .priority = 3, .stayalive = False})
                    Else
                        With v_widgetdb
                            .BeginEdit()
                            .para_date1 = v_toprecs.DBWidget.para_date1
                            .para_date2 = v_toprecs.DBWidget.para_date2
                            .para_int1 = v_toprecs.DBWidget.para_int1
                            .para_bol1 = v_toprecs.DBWidget.para_bol1
                            .EndEdit()
                        End With
                        dbo.SaveChanges()
                    End If
                Else
                    v_toprecs.CancelEdit()
                End If
            End With
        End Sub

#End Region

#Region "Receiver Chart"
        Public Property cmdChart_Receivers_Update As New RelayCommand(Of cls_home_receivers)(Sub(p) Chart_Receivers_Updater(p), Function(p) p IsNot Nothing)
        Public Property cmdDashboardWidgetSettingsReceivers As New RelayCommand(Of cls_home_receivers)(Sub(p) DashboardWidgetSettingsReceivers(p), Function(p) p IsNot Nothing)

        Private Function Chart_Receivers_Updater(v_widget As cls_home_receivers) As Boolean
            If v_widget Is Nothing Then Return False
            With v_widget
                Try
                    .Chart_Recs_Series.Clear()
                Catch ex As Exception
                    Debug.Print("Chart Recs Error:" & ex.Exception.ToString)
                End Try

                .Chart_Recs_Labels.Clear()
                'Selected Receivers are stored in para_str1 with delimiter ;
                Dim v_column As New RowSeries With {.Title = "Empfänger"}
                Dim v_values As New ChartValues(Of Double)

                If Not Receivers_Aktiv Is Nothing AndAlso String.IsNullOrEmpty(v_widget.DBWidget.para_str1) = False Then
                    Dim v_selected_recs As New List(Of receiver_v01)
                    Dim v_sel_recs_ids As String() = v_widget.DBWidget.para_str1.Split(";")
                    For i As Integer = 0 To v_sel_recs_ids.Count - 1
                        Dim v_ci As Integer = i
                        If __reveicer.Where(Function(x) x.rec_id = CInt(v_sel_recs_ids(v_ci)) AndAlso CBool(x.aktiv) = True).FirstOrDefault IsNot Nothing Then
                            v_selected_recs.Add(__reveicer.Where(Function(x) x.rec_id = CInt(v_sel_recs_ids(v_ci)) AndAlso CBool(x.aktiv) = True).FirstOrDefault)
                        End If
                    Next
                    If v_selected_recs IsNot Nothing AndAlso v_selected_recs.Count > 0 Then
                        'Caluclate the timespan based totamount:
                        For Each v_item As receiver_v01 In v_selected_recs
                            v_item.totamount_timespan_caluclator(v_widget.DBWidget.para_date1, v_widget.DBWidget.para_date2)
                            .Chart_Recs_Labels.Add(v_item.bezeichnung)
                            v_values.Add(v_item.totamount_timespan)
                        Next
                    End If
                    v_column.Values = v_values
                    .Chart_Recs_Series.Add(v_column)
                End If
            End With

            Return True
        End Function

        Private Sub DashboardWidgetSettingsReceivers(v_recs As cls_home_receivers)
            If v_recs Is Nothing Then Exit Sub
            Dim v_dia As New ucl_home_receiver_settings
            With v_dia
                v_recs.BeginEdit()
                .DataContext = v_recs
                .ShowDialog()
                If .DialogResult Then
                    v_recs.EndEdit()
                    Chart_Receivers_Updater(v_recs)
                    'The settings of the Widget should be saved to the database:
                    Dim v_widgetdb As widgets_v01 = __widgetsdb.Where(Function(x) x.Id = v_recs.DBWidget.Id).FirstOrDefault
                    If v_widgetdb Is Nothing Then
                        cls_logger.v_logger.Error(String.Format("Widget mit ID {0} konnte nicht gefunden werden", v_recs.DBWidget.Id))
                        MessageAdd(New message_v01 With {.header = "Fehler Widget Einstellungen", .iserrormsg = True, .message = "Einstellungen des Widgets Receiver konnten nicht übernommen werden", .priority = 3, .stayalive = False})
                    Else
                        With v_widgetdb
                            .BeginEdit()
                            .para_date1 = v_recs.DBWidget.para_date1
                            .para_date2 = v_recs.DBWidget.para_date2
                            .para_str1 = v_recs.DBWidget.para_str1
                            .EndEdit()
                        End With
                        dbo.SaveChanges()
                    End If
                Else
                    v_recs.CancelEdit()
                End If
            End With
        End Sub

#End Region

#Region "Top Persons Chart"
        Public Property cmdChart_TopPersons_Update As New RelayCommand(Of cls_home_toppersons)(Sub(p) Chart_TopPersons_Updater(p), Function(p) p IsNot Nothing)
        Public Property cmdDashboardWidgetSettingsTopPersons As New RelayCommand(Of cls_home_toppersons)(Sub(p) DashboardWidgetSettingsTopPersons(p), Function(p) p IsNot Nothing)

        Private Function Chart_TopPersons_Updater(v_widget As cls_home_toppersons) As Boolean
            If v_widget Is Nothing Then Return False
            With v_widget
                Try
                    .Chart_TopPers_Series.Clear()
                Catch ex As Exception
                    Debug.Print("Chart TopCats Error:" & ex.Exception.ToString)
                End Try

                .Chart_TopPers_Labels.Clear()

                Dim v_column As New ColumnSeries With {.Title = "Personen"}
                Dim v_values As New ChartValues(Of Double)
                Dim v_count As Integer = 1
                If Not Persons_Aktiv Is Nothing AndAlso Persons_Aktiv.Count > 0 Then
                    Dim v_pers_temp As ListCollectionView = New ListCollectionView(__persons) With {.Filter = New Predicate(Of Object)(AddressOf Filters.ObjAktiv)}
                    'Caluclate the timespan based totamount before sorting:
                    For Each v_item As person_v01 In v_pers_temp
                        v_item.totamount_timespan_caluclator(v_widget.DBWidget.para_date1, v_widget.DBWidget.para_date2, If(v_widget.DBWidget.para_bol1, CShort(1), CShort(-1)))
                    Next
                    'Apply a filter to remove all 0 amounts:
                    If v_widget.DBWidget.para_bol1 = True Then
                        v_pers_temp.Filter = New Predicate(Of Object)(AddressOf Filters.TotAmountTimespanBiggerZero)
                    Else
                        v_pers_temp.Filter = New Predicate(Of Object)(AddressOf Filters.TotAmountTimespanSmallerZero)
                    End If
                    'Apply Sort:
                    v_pers_temp.SortDescriptions.Add(New ComponentModel.SortDescription With {.PropertyName = "totamount_timespan", .Direction = ComponentModel.ListSortDirection.Ascending})

                    For Each v_pers As person_v01 In v_pers_temp
                        If v_count <= v_widget.DBWidget.para_int1 Then
                            .Chart_TopPers_Labels.Add(v_pers.bezeichnung)
                            v_values.Add(v_pers.totamount_timespan)
                            v_count += 1
                        Else
                            Exit For
                        End If
                    Next
                    v_column.Values = v_values
                    .Chart_TopPers_Series.Add(v_column)
                    v_pers_temp = Nothing
                End If
            End With

            Return True
        End Function

        Private Sub DashboardWidgetSettingsTopPersons(v_toppers As cls_home_toppersons)
            If v_toppers Is Nothing Then Exit Sub

            Dim v_dia As New ucl_home_toppersons_settings

            With v_dia
                v_toppers.BeginEdit()
                .DataContext = v_toppers
                .ShowDialog()
                If .DialogResult Then
                    v_toppers.EndEdit()
                    Chart_TopPersons_Updater(v_toppers)
                    'The settings of the Widget should be saved to the database:
                    Dim v_widgetdb As widgets_v01 = __widgetsdb.Where(Function(x) x.Id = v_toppers.DBWidget.Id).FirstOrDefault
                    If v_widgetdb Is Nothing Then
                        cls_logger.v_logger.Error(String.Format("Widget mit ID {0} konnte nicht gefunden werden", v_toppers.DBWidget.Id))
                        MessageAdd(New message_v01 With {.header = "Fehler Widget Einstellungen", .iserrormsg = True, .message = "Einstellungen des Widgets Top Personen konnten nicht übernommen werden", .priority = 3, .stayalive = False})
                    Else
                        With v_widgetdb
                            .BeginEdit()
                            .para_date1 = v_toppers.DBWidget.para_date1
                            .para_date2 = v_toppers.DBWidget.para_date2
                            .para_int1 = v_toppers.DBWidget.para_int1
                            .para_bol1 = v_toppers.DBWidget.para_bol1
                            .EndEdit()
                        End With
                        dbo.SaveChanges()
                    End If
                Else
                    v_toppers.CancelEdit()
                End If
            End With
        End Sub

#End Region

#Region "Person Chart"
        Public Property cmdChart_Persons_Update As New RelayCommand(Of cls_home_persons)(Sub(p) Chart_Persons_Updater(p), Function(p) p IsNot Nothing)
        Public Property cmdDashboardWidgetSettingsPersons As New RelayCommand(Of cls_home_persons)(Sub(p) DashboardWidgetSettingsPersons(p), Function(p) p IsNot Nothing)

        Private Function Chart_Persons_Updater(v_widget As cls_home_persons) As Boolean
            If v_widget Is Nothing Then Return False
            With v_widget
                Try
                    .Chart_Pers_Series.Clear()
                Catch ex As Exception
                    Debug.Print("Chart Pers Error:" & ex.Exception.ToString)
                End Try

                .Chart_Pers_Labels.Clear()
                'Selected Persons are stored in para_str1 with delimiter ;
                Dim v_column As New RowSeries With {.Title = "Personen"}
                Dim v_values As New ChartValues(Of Double)

                If Not Persons_Aktiv Is Nothing AndAlso String.IsNullOrEmpty(v_widget.DBWidget.para_str1) = False Then
                    Dim v_selected_pers As New List(Of person_v01)
                    Dim v_sel_pers_ids As String() = v_widget.DBWidget.para_str1.Split(";")
                    For i As Integer = 0 To v_sel_pers_ids.Count - 1
                        Dim v_ci As Integer = i
                        If __persons.Where(Function(x) x.pers_id = CInt(v_sel_pers_ids(v_ci)) AndAlso CBool(x.aktiv) = True).FirstOrDefault IsNot Nothing Then
                            v_selected_pers.Add(__persons.Where(Function(x) x.pers_id = CInt(v_sel_pers_ids(v_ci)) AndAlso CBool(x.aktiv) = True).FirstOrDefault)
                        End If
                    Next
                    If v_selected_pers IsNot Nothing AndAlso v_selected_pers.Count > 0 Then
                        'Caluclate the timespan based totamount:
                        For Each v_item As person_v01 In v_selected_pers
                            v_item.totamount_timespan_caluclator(v_widget.DBWidget.para_date1, v_widget.DBWidget.para_date2, If(v_widget.DBWidget.para_bol1, CShort(1), CShort(-1)))
                            .Chart_Pers_Labels.Add(v_item.bezeichnung)
                            v_values.Add(v_item.totamount_timespan)
                        Next
                    End If
                    v_column.Values = v_values
                    .Chart_Pers_Series.Add(v_column)
                End If
            End With

            Return True
        End Function

        Private Sub DashboardWidgetSettingsPersons(v_pers As cls_home_persons)
            If v_pers Is Nothing Then Exit Sub
            Dim v_dia As New ucl_home_persons_settings
            With v_dia
                v_pers.BeginEdit()
                .DataContext = v_pers
                .ShowDialog()
                If .DialogResult Then
                    v_pers.EndEdit()
                    Chart_Persons_Updater(v_pers)
                    'The settings of the Widget should be saved to the database:
                    Dim v_widgetdb As widgets_v01 = __widgetsdb.Where(Function(x) x.Id = v_pers.DBWidget.Id).FirstOrDefault
                    If v_widgetdb Is Nothing Then
                        cls_logger.v_logger.Error(String.Format("Widget mit ID {0} konnte nicht gefunden werden", v_pers.DBWidget.Id))
                        MessageAdd(New message_v01 With {.header = "Fehler Widget Einstellungen", .iserrormsg = True, .message = "Einstellungen des Widgets Persons konnten nicht übernommen werden", .priority = 3, .stayalive = False})
                    Else
                        With v_widgetdb
                            .BeginEdit()
                            .para_date1 = v_pers.DBWidget.para_date1
                            .para_date2 = v_pers.DBWidget.para_date2
                            .para_str1 = v_pers.DBWidget.para_str1
                            .EndEdit()
                        End With
                        dbo.SaveChanges()
                    End If
                Else
                    v_pers.CancelEdit()
                End If
            End With
        End Sub

#End Region




    End Class

End Namespace