﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Threading
Imports System.Windows.Threading

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial: Avalondock Menüsystem
        Private WithEvents __menucollection As New ObservableCollection(Of Object)
        Public Property MenuCollection As ListCollectionView
        Dim v_menucurrentobject As Object

        'Properties für die Fenster welche keine Entitäten sind im Avalondock:
        Public Property MenuVerwaltung As New cls_menuitem_verwaltung
        Public Property MenuHome As New cls_menuitem_home
        Public Property MenuTransRepeatOverview As New cls_menuitem_transrep_overview
        Public Property MenuTransTemplateOverview As New cls_menuitem_transtemp_overview
        Public Property MenuTransStack As New cls_menuitem_transstack
        Public Property MenuDocuments As New cls_menuitem_documents
        Public Property MenuArchiv As New cls_menuitem_archiv
        Public Property MenuBalancer As New cls_menuitem_balancer
        Public Property MenuSavingTargets As New cls_menuitem_savingtargets

        Public Property MenuCurrentObject As Object
            Get
                Return v_menucurrentobject
            End Get
            Set(value As Object)
                v_menucurrentobject = value
                RaisePropertyChanged("MenuCurrentObject")
                'Debug.Print("MenuCurrentObject changed to: " & value.ToString)
                'Set all to collapsed
                ContextKontoActive = Visibility.Collapsed
                ContextKontoJournalActive = Visibility.Collapsed
                ContextReportsActive = Visibility.Collapsed
                ContextSearchActive = Visibility.Collapsed
                ContextBudgetActive = Visibility.Collapsed
                ContextTransRepActive = Visibility.Collapsed
                ContextTransTempActive = Visibility.Collapsed
                ContextTransStackActive = Visibility.Collapsed
                ContextDocumentsActive = Visibility.Collapsed
                ContextArchivActive = Visibility.Collapsed
                ContextBalancerActive = Visibility.Collapsed
                ContextSavingTargetsActive = Visibility.Collapsed

                Select Case True
                    Case TypeOf (value) Is konto_v01
                        ContextKontoActive = Visibility.Visible
                    Case TypeOf (value) Is bookjournal_v01
                        ContextKontoJournalActive = Visibility.Visible
                    Case TypeOf (value) Is report_base_v01
                        ContextReportsActive = Visibility.Visible
                    Case TypeOf (value) Is searchdefinition_v01
                        ContextSearchActive = Visibility.Visible
                    Case TypeOf (value) Is budget_v01
                        ContextBudgetActive = Visibility.Visible
                    Case TypeOf (value) Is cls_menuitem_transrep_overview
                        ContextTransRepActive = Visibility.Visible
                    Case TypeOf (value) Is cls_menuitem_transtemp_overview
                        ContextTransTempActive = Visibility.Visible
                    Case TypeOf (value) Is cls_menuitem_transstack
                        ContextTransStackActive = Visibility.Visible
                    Case TypeOf (value) Is cls_menuitem_documents
                        ContextDocumentsActive = Visibility.Visible
                    Case TypeOf (value) Is cls_menuitem_archiv
                        ContextArchivActive = Visibility.Visible
                    Case TypeOf (value) Is cls_menuitem_balancer
                        ContextBalancerActive = Visibility.Visible
                    Case TypeOf (value) Is cls_menuitem_kontoreport
                        ContextKontoReportActive = Visibility.Visible
                    Case TypeOf (value) Is cls_menuitem_savingtargets
                        ContextSavingTargetsActive = Visibility.Visible
                End Select

                If ContextKontoSelected = False AndAlso
                        ContextKontoJournalSelected = False AndAlso
                    ContextTransTempSelected = False AndAlso
                    ContextTransRepSelected = False AndAlso
                    ContextTransStackSelected = False AndAlso
                    ContextDocumentsSelected = False AndAlso
                    ContextSearchSelected = False AndAlso
                    ContextBudgetSelected = False AndAlso
                    ContextBalancerSelected = False AndAlso
                    ContextSavingTargetsSelected = False AndAlso
                    ContextReportsSelected = False AndAlso
                    ContextKontoReportSelected = False _
                    Then AllgemeinSelected = True

            End Set

        End Property

        Dim v_allgemein_selected As Boolean = True
        Public Property AllgemeinSelected As Boolean
            Get
                Return v_allgemein_selected
            End Get
            Set(value As Boolean)
                v_allgemein_selected = value
                RaisePropertyChanged("AllgemeinSelected")
            End Set
        End Property

        Dim v_context_konto_active As Visibility = Visibility.Collapsed
        Public Property ContextKontoActive As Visibility
            Get
                Return v_context_konto_active
            End Get
            Set(value As Visibility)
                ' If Not v_context_konto_active.Equals(value) Then
                v_context_konto_active = value
                If v_context_konto_active = Visibility.Visible Then
                    ContextKontoSelected = True
                    AllgemeinSelected = False
                Else
                    ContextKontoSelected = False
                End If
                RaisePropertyChanged("ContextKontoActive")
                ' End If
            End Set
        End Property

        Dim v_context_konto_selected As Boolean
        Public Property ContextKontoSelected As Boolean
            Get
                Return v_context_konto_selected
            End Get
            Set(value As Boolean)
                v_context_konto_selected = value
                RaisePropertyChanged("ContextKontoSelected")
            End Set
        End Property

        Dim v_context_kontojournal_active As Visibility = Visibility.Collapsed
        Public Property ContextKontoJournalActive As Visibility
            Get
                Return v_context_kontojournal_active
            End Get
            Set(value As Visibility)
                v_context_kontojournal_active = value
                If v_context_kontojournal_active = Visibility.Visible Then
                    ContextKontoJournalSelected = True
                Else
                    ContextKontoJournalSelected = False
                End If
                RaisePropertyChanged("ContextKontoJournalActive")
            End Set
        End Property

        Dim v_context_kontojournal_selected As Boolean = False
        Public Property ContextKontoJournalSelected As Boolean
            Get
                Return v_context_kontojournal_selected
            End Get
            Set(value As Boolean)
                v_context_kontojournal_selected = value
                RaisePropertyChanged("ContextKontoJournalSelected")
            End Set
        End Property

        Dim v_context_kontoreport_active As Visibility = Visibility.Collapsed
        Public Property ContextKontoReportActive As Visibility
            Get
                Return v_context_kontoreport_active
            End Get
            Set(value As Visibility)
                v_context_kontoreport_active = value
                If v_context_kontoreport_active = Visibility.Visible Then
                    ContextKontoReportSelected = True
                Else
                    ContextKontoReportSelected = False
                End If
                RaisePropertyChanged("ContextKontoReportActive")
            End Set
        End Property

        Dim v_context_kontoreport_selected As Boolean = False
        Public Property ContextKontoReportSelected As Boolean
            Get
                Return v_context_kontoreport_selected
            End Get
            Set(value As Boolean)
                v_context_kontoreport_selected = value
                RaisePropertyChanged("ContextKontoReportSelected")
            End Set
        End Property

        Dim v_context_search_active As Visibility = Visibility.Collapsed
        Public Property ContextSearchActive As Visibility
            Get
                Return v_context_search_active
            End Get
            Set(value As Visibility)
                v_context_search_active = value
                If v_context_search_active = Visibility.Visible Then
                    ContextSearchSelected = True
                    AllgemeinSelected = False
                Else
                    ContextSearchSelected = False
                End If
                RaisePropertyChanged("ContextSearchActive")
                ' End If
            End Set
        End Property

        Dim v_context_search_selected As Boolean
        Public Property ContextSearchSelected As Boolean
            Get
                Return v_context_search_selected
            End Get
            Set(value As Boolean)
                v_context_search_selected = value
                RaisePropertyChanged("ContextSearchSelected")
            End Set
        End Property

        Dim v_context_budget_active As Visibility = Visibility.Collapsed
        Public Property ContextBudgetActive As Visibility
            Get
                Return v_context_budget_active
            End Get
            Set(value As Visibility)
                v_context_budget_active = value
                If v_context_budget_active = Visibility.Visible Then
                    ContextBudgetSelected = True
                    AllgemeinSelected = False
                Else
                    ContextBudgetSelected = False
                End If
                RaisePropertyChanged("ContextBudgetActive")
            End Set
        End Property

        Dim v_context_budget_selected As Boolean
        Public Property ContextBudgetSelected As Boolean
            Get
                Return v_context_budget_selected
            End Get
            Set(value As Boolean)
                v_context_budget_selected = value
                RaisePropertyChanged("ContextBudgetSelected")
            End Set
        End Property

        Dim v_context_transrep_active As Visibility = Visibility.Collapsed
        Public Property ContextTransRepActive As Visibility
            Get
                Return v_context_transrep_active
            End Get
            Set(value As Visibility)
                v_context_transrep_active = value
                If v_context_transrep_active = Visibility.Visible Then
                    ContextTransRepSelected = True
                    AllgemeinSelected = False
                Else
                    ContextTransRepSelected = False
                End If
                RaisePropertyChanged("ContextTransRepActive")
            End Set
        End Property

        Dim v_context_transrep_selected As Boolean
        Public Property ContextTransRepSelected As Boolean
            Get
                Return v_context_transrep_selected
            End Get
            Set(value As Boolean)
                v_context_transrep_selected = value
                RaisePropertyChanged("ContextTransRepSelected")
            End Set
        End Property

        Dim v_context_transtemp_active As Visibility = Visibility.Collapsed
        Public Property ContextTransTempActive As Visibility
            Get
                Return v_context_transtemp_active
            End Get
            Set(value As Visibility)
                v_context_transtemp_active = value
                If v_context_transtemp_active = Visibility.Visible Then
                    ContextTransTempSelected = True
                    AllgemeinSelected = False
                Else
                    ContextTransTempSelected = False
                End If
                RaisePropertyChanged("ContextTransTempActive")
            End Set
        End Property

        Dim v_context_transtemp_selected As Boolean
        Public Property ContextTransTempSelected As Boolean
            Get
                Return v_context_transtemp_selected
            End Get
            Set(value As Boolean)
                v_context_transtemp_selected = value
                RaisePropertyChanged("ContextTransTempSelected")
            End Set
        End Property

        Dim v_context_transstack_active As Visibility = Visibility.Collapsed
        Public Property ContextTransStackActive As Visibility
            Get
                Return v_context_transstack_active
            End Get
            Set(value As Visibility)
                v_context_transstack_active = value
                If v_context_transstack_active = Visibility.Visible Then
                    ContextTransStackSelected = True
                    AllgemeinSelected = False
                Else
                    ContextTransStackSelected = False
                End If
                RaisePropertyChanged("ContextTransStackActive")
            End Set
        End Property

        Dim v_context_transstack_selected As Boolean
        Public Property ContextTransStackSelected As Boolean
            Get
                Return v_context_transstack_selected
            End Get
            Set(value As Boolean)
                v_context_transstack_selected = value
                RaisePropertyChanged("ContextTransStackSelected")
            End Set
        End Property

        Dim v_context_documents_active As Visibility = Visibility.Collapsed
        Public Property ContextDocumentsActive As Visibility
            Get
                Return v_context_documents_active
            End Get
            Set(value As Visibility)
                v_context_documents_active = value
                If v_context_documents_active = Visibility.Visible Then
                    ContextDocumentsSelected = True
                    AllgemeinSelected = False
                Else
                    ContextDocumentsSelected = False
                End If
                RaisePropertyChanged("ContextDocumentsActive")
            End Set
        End Property

        Dim v_context_documents_selected As Boolean
        Public Property ContextDocumentsSelected As Boolean
            Get
                Return v_context_documents_selected
            End Get
            Set(value As Boolean)
                v_context_documents_selected = value
                RaisePropertyChanged("ContextDocumentsSelected")
            End Set
        End Property

        Dim v_context_archiv_active As Visibility = Visibility.Collapsed
        Public Property ContextArchivActive As Visibility
            Get
                Return v_context_archiv_active
            End Get
            Set(value As Visibility)
                v_context_archiv_active = value
                If v_context_archiv_active = Visibility.Visible Then
                    ContextArchivSelected = True
                    AllgemeinSelected = False
                Else
                    ContextArchivSelected = False
                End If
                RaisePropertyChanged("ContextArchivActive")
            End Set
        End Property

        Dim v_context_archiv_selected As Boolean
        Public Property ContextArchivSelected As Boolean
            Get
                Return v_context_archiv_selected
            End Get
            Set(value As Boolean)
                v_context_archiv_selected = value
                RaisePropertyChanged("ContextArchivSelected")
            End Set
        End Property

        Dim v_context_balancer_active As Visibility = Visibility.Collapsed
        Public Property ContextBalancerActive As Visibility
            Get
                Return v_context_balancer_active
            End Get
            Set(value As Visibility)
                v_context_balancer_active = value
                If v_context_balancer_active = Visibility.Visible Then
                    ContextBalancerSelected = True
                    AllgemeinSelected = False
                Else
                    ContextBalancerSelected = False
                End If
                RaisePropertyChanged("ContextBalancerActive")
            End Set
        End Property

        Dim v_context_balancer_selected As Boolean
        Public Property ContextBalancerSelected As Boolean
            Get
                Return v_context_balancer_selected
            End Get
            Set(value As Boolean)
                v_context_balancer_selected = value
                RaisePropertyChanged("ContextBalancerSelected")
            End Set
        End Property

        Dim v_context_savingtargets_active As Visibility = Visibility.Collapsed
        Public Property ContextSavingTargetsActive As Visibility
            Get
                Return v_context_savingtargets_active
            End Get
            Set(value As Visibility)
                v_context_savingtargets_active = value
                If v_context_savingtargets_active = Visibility.Visible Then
                    ContextSavingTargetsSelected = True
                    AllgemeinSelected = False
                Else
                    ContextSavingTargetsSelected = False
                End If
                RaisePropertyChanged("ContextSavingTargetsActive")
            End Set
        End Property

        Dim v_context_savingtargets_selected As Boolean
        Public Property ContextSavingTargetsSelected As Boolean
            Get
                Return v_context_savingtargets_selected
            End Get
            Set(value As Boolean)
                v_context_savingtargets_selected = value
                RaisePropertyChanged("ContextSavingTargetsSelected")
            End Set
        End Property

        Dim v_context_reports_active As Visibility = Visibility.Collapsed
        Public Property ContextReportsActive As Visibility
            Get
                Return v_context_reports_active
            End Get
            Set(value As Visibility)
                v_context_reports_active = value
                If v_context_reports_active = Visibility.Visible Then
                    ContextReportsSelected = True
                    AllgemeinSelected = False
                Else
                    ContextReportsSelected = False
                End If
                RaisePropertyChanged("ContextReportsActive")
            End Set
        End Property

        Dim v_context_reports_selected As Boolean
        Public Property ContextReportsSelected As Boolean
            Get
                Return v_context_reports_selected
            End Get
            Set(value As Boolean)
                v_context_reports_selected = value
                RaisePropertyChanged("ContextReportsSelected")
            End Set
        End Property

        Private Sub MenuLoad()
            __menucollection.Clear()
            MenuCollection = New ListCollectionView(__menucollection)
        End Sub

        Private Sub __menucollection_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __menucollection.CollectionChanged
            If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not MenuCollection.MoveCurrentToNext Then MenuCollection.MoveCurrentToPrevious()
        End Sub

#Region "Commands"

        Public Property cmdMenuAdd As New RelayCommand(Of Object)(Sub(p) MenuAdd(p), Function(p) MenuAddCanExecute(p))


        Private Function MenuAddCanExecute(v_obj As Object) As Boolean
            If v_obj Is Nothing Then Return False

            'The archiv has to be checked before all other elements:
            If TypeOf (v_obj) Is cls_menuitem_archiv Then
                'Folder Konto Budget
                Dim v_can_fol_ex As Boolean = True
                Dim v_can_kto_ex As Boolean = True
                Dim v_can_bud_ex As Boolean = True

                If Folders_Inaktiv Is Nothing OrElse Folders_Inaktiv.Count = 0 Then v_can_fol_ex = False
                If Konten_Inaktiv Is Nothing OrElse Konten_Inaktiv.Count = 0 Then v_can_kto_ex = False
                If Budgets_InAktiv Is Nothing OrElse Budgets_InAktiv.Count = 0 Then v_can_bud_ex = False

                If v_can_fol_ex = False AndAlso v_can_kto_ex = False AndAlso v_can_bud_ex = False Then Return False
            End If

            If TypeOf (v_obj) Is cls_menuitem_verwaltung Then Return True
            If TypeOf (v_obj) Is settings Then Return True
            If TypeOf (v_obj) Is cls_menuitem_home Then Return True
            'Deactivate every command as long as no folder or aktiv konto is available:
            If Folders_Aktiv Is Nothing OrElse Folders_Aktiv.Count = 0 OrElse Konten_Aktiv Is Nothing OrElse Konten_Aktiv.Count = 0 Then Return False

            Select Case True
                'Case TypeOf (v_obj) Is konto_v01
                'Case TypeOf (v_obj) Is cls_menuitem_kontoreport
                'Case TypeOf (v_obj) Is bookjournal_v01
                'Case TypeOf (v_obj) Is searchdefinition_v01
                'Case TypeOf (v_obj) Is budget_v01
                'Case TypeOf (v_obj) Is cls_menuitem_transrep_overview
                'Case TypeOf (v_obj) Is cls_menuitem_savingtargets
                'Case TypeOf (v_obj) Is cls_menuitem_transtemp_overview
                'Case TypeOf (v_obj) Is cls_menuitem_transstack
                Case TypeOf (v_obj) Is report_base_v01
                    If __transactions Is Nothing OrElse __transactions.Count = 0 Then Return False
                Case TypeOf (v_obj) Is cls_menuitem_documents
                    If DocumentList Is Nothing OrElse DocumentList.Count = 0 Then Return False
                Case TypeOf (v_obj) Is cls_menuitem_balancer
                    If Persons_Aktiv Is Nothing OrElse Persons_Aktiv.Count = 0 Then Return False
                Case Else
                    Return True
            End Select
            Return True

        End Function

        Private Sub MenuAdd(v_mobj As Object)
            If v_mobj Is Nothing Then Exit Sub
            GlobalBusy = True
            Dim thrstart As ThreadStart = Sub()
                                              Application.Current.Dispatcher.Invoke(DispatcherPriority.Background, New Action(Sub()
                                                                                                                                  MenuAddDo(v_mobj)
                                                                                                                              End Sub))
                                              GlobalBusy = False
                                          End Sub
            Dim thr As New Thread(thrstart) With {.Name = "MenuAdd", .IsBackground = True, .Priority = ThreadPriority.Normal}
            thr.SetApartmentState(ApartmentState.STA)
            thr.Start()
        End Sub


        Private Sub MenuAddDo(v_mobj As Object)
            Dim type = v_mobj.GetType
            Dim ref_eventinfo As Reflection.EventInfo = type.GetEvent("PropertyChanged")
            If ref_eventinfo = Nothing Then
                'Falsches Element für das Menü
                cls_logger.v_logger.Error("Fehler in MenuAdd mit Objekt:" & v_mobj.ToString & " " & v_mobj.GetType.ToString)
                Exit Sub
            End If
            ref_eventinfo.AddEventHandler(v_mobj, New PropertyChangedEventHandler(AddressOf MenuItemPropertyChanged))

            'Prüfen ob das Element nicht bereits vorhanden ist:
            If Not MenuCollection.Contains(v_mobj) Then
                MenuCollection.AddNewItem(v_mobj)
                MenuCollection.CommitNew()
                If TypeOf (v_mobj) Is settings Then SettingsCurrent.BeginEdit()
            End If
            'Aktiv machen:
            MenuCurrentObject = v_mobj
            MenuCollection.MoveCurrentTo(v_mobj)

            If TypeOf (v_mobj) Is konto_v01 Then
                ContextKontoActive = Visibility.Visible
                'Setting Standard Filter of Konto Transactions to current month (initially the filter is set in a property of the konto:
                KontoFilterView(DirectCast(v_mobj, konto_v01))
                'setting Sorting to Date descending
                KontoSorterView(DirectCast(v_mobj, konto_v01))
            Else
                ContextKontoActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is cls_menuitem_kontoreport Then
                ContextKontoReportActive = Visibility.Visible
            Else
                ContextKontoReportActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is report_base_v01 Then
                ContextReportsActive = Visibility.Visible
                DirectCast(v_mobj, report_base_v01).BeginEdit()
            Else
                ContextReportsActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is bookjournal_v01 Then
                ContextKontoJournalActive = Visibility.Visible
                'Setting Standard Filter of Konto Transactions to current month:
                Dim v_tf As cls_timeframe = __timeframes_view.First(Function(p) p.Id = 2) 'Current Month
                Dim v_paras As Object() = {v_mobj, v_tf}
                If Not v_tf Is Nothing Then JournalFilter(v_paras)
                'setting Soritng to Date descending
                JournalSorter(DirectCast(v_mobj, bookjournal_v01))
            Else
                ContextKontoJournalActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is searchdefinition_v01 Then
                ContextSearchActive = Visibility.Visible
            Else
                ContextSearchActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is budget_v01 Then
                'DirectCast(v_mobj, budget_v01).do_report()
                'DEAKTIVIERT UM LADEZEIT ZU VERBESSERN

                'BudgetDoReport(DirectCast(v_mobj, budget_v01))
                ContextBudgetActive = Visibility.Visible
            Else
                ContextBudgetActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is cls_menuitem_transrep_overview Then
                ContextTransRepActive = Visibility.Visible
            Else
                ContextTransRepActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is cls_menuitem_savingtargets Then
                ContextSavingTargetsActive = Visibility.Visible
            Else
                ContextSavingTargetsActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is cls_menuitem_transtemp_overview Then
                ContextTransTempActive = Visibility.Visible
            Else
                ContextTransTempActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is cls_menuitem_transstack Then
                'Define the presets:
                With StackTransactions
                    .preset_date = Date.Now
                    .preset_konto_id = TryCast(Konten_Aktiv.CurrentItem, konto_v01).kto_id
                    .preset_person_id = TryCast(Persons_Aktiv.CurrentItem, person_v01).pers_id
                    .preset_receiver_id = TryCast(Receivers_Aktiv.CurrentItem, receiver_v01).rec_id
                    .preset_status_id = TryCast(TransStatus_Aktiv.CurrentItem, trans_status_v01).status_id
                    .preset_category_id = TryCast(Categories_Aktiv.CurrentItem, category_v01).cat_id
                    .preset_typ_id = TryCast(TransTypen.CurrentItem, trans_typ_v01).typ_id
                End With

                ContextTransStackActive = Visibility.Visible
            Else
                ContextTransStackActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is cls_menuitem_documents Then
                ContextDocumentsActive = Visibility.Visible
                TimeFramesView.MoveCurrentToPosition(1)
                DocumentsFilterView(DirectCast(TimeFramesView.CurrentItem, cls_timeframe))
            Else
                ContextDocumentsActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is cls_menuitem_archiv Then
                ContextArchivActive = Visibility.Visible
            Else
                ContextArchivActive = Visibility.Collapsed
            End If

            If TypeOf (v_mobj) Is cls_menuitem_balancer Then
                ContextBalancerActive = Visibility.Visible
            Else
                ContextBalancerActive = Visibility.Collapsed
            End If

        End Sub

        Public Sub VerwaltungClose()
            If TransTypen.CanCancelEdit Then TransTypen.CancelEdit()
            TransTypen.CancelNew()
            If TransStatus.CanCancelEdit Then TransStatus.CancelEdit()
            TransStatus.CancelNew()
            If Receivers.CanCancelEdit Then Receivers.CancelEdit()
            Receivers.CancelNew()
            If Persons.CanCancelEdit Then Persons.CancelEdit()
            Persons.CancelNew()
            If Tags.CanCancelEdit Then Tags.CancelEdit()
            Tags.CancelNew()
            If Categories_MainCats_All.CanCancelEdit Then Categories_MainCats_All.CancelEdit()
            Categories_MainCats_All.CancelNew()
        End Sub

        Private Sub MenuItemPropertyChanged(sender As Object, e As PropertyChangedEventArgs)
            Select Case True
                Case TypeOf (sender) Is cls_menuitem_verwaltung
                    'Wenn die Verwaltung beendet wird prüfen ob die gebündelten Entitäten im AddNew oder Edit sind:
                    VerwaltungClose()
                    dbo.SaveChanges()

                    'Now update the Views:
                    __status_CollectionChanged(Nothing, Nothing)
                    __reveicer_CollectionChanged(Nothing, Nothing)
                    __persons_CollectionChanged(Nothing, Nothing)
                    __tags_CollectionChanged(Nothing, Nothing)
                    __categories_CollectionChanged(Nothing, Nothing)
                    __typen_CollectionChanged(Nothing, Nothing)

                Case TypeOf (sender) Is settings
                    '    'Update the Document Watcher if activ:
                    '    If SettingsCurrent.doc_watcher_use Then
                    '        InitDocWatcher()
                    '    End If
                    dbo.SaveChanges()
            End Select
            If e.PropertyName.ToLower = "IsClosed".ToLower Then
                MenuCollection.Remove(sender)
                MenuCurrentObject = MenuCollection.CurrentItem
            End If

            'check if there is still a Konto:
            If Not check_konto_present() Then ContextKontoActive = Visibility.Collapsed
            'check if there is still a bookingjournal
            If Not check_konto_journal_present() Then ContextKontoJournalActive = Visibility.Collapsed
            'check if there is still a konto report
            If Not check_konto_report_present Then ContextKontoReportActive = Visibility.Collapsed
            'check if there is still a Search:
            If Not check_search_present() Then ContextSearchActive = Visibility.Collapsed
            'check if there is still a Budget:
            If Not check_budget_present() Then ContextBudgetActive = Visibility.Collapsed
            'check if there is still a report:
            If Not check_report_present() Then ContextReportsActive = Visibility.Collapsed
        End Sub

        Private Function check_konto_present() As Boolean
            For Each v_obj As Object In MenuCollection
                If TypeOf (v_obj) Is konto_v01 Then Return True
            Next
            Return False
        End Function

        Private Function check_konto_journal_present() As Boolean
            For Each v_obj As Object In MenuCollection
                If TypeOf (v_obj) Is bookjournal_v01 Then Return True
            Next
            Return False
        End Function

        Private Function check_konto_report_present() As Boolean
            For Each v_obj As Object In MenuCollection
                If TypeOf (v_obj) Is cls_menuitem_kontoreport Then Return True
            Next
            Return False
        End Function

        Private Function check_search_present() As Boolean
            For Each v_obj As Object In MenuCollection
                If TypeOf (v_obj) Is searchdefinition_v01 Then Return True
            Next
            Return False
        End Function

        Private Function check_budget_present() As Boolean
            For Each v_obj As Object In MenuCollection
                If TypeOf (v_obj) Is budget_v01 Then Return True
            Next
            Return False
        End Function

        Private Function check_report_present() As Boolean
            For Each v_obj As Object In MenuCollection
                If TypeOf (v_obj) Is report_base_v01 Then Return True
            Next
            Return False
        End Function

        Private Function MenuCanClose(v_mobj As Object) As Boolean
            If v_mobj Is Nothing Then Return False

            'check if canclose Property is available:
            Dim type As Type = v_mobj.GetType

            If type.GetProperty("canClose") IsNot Nothing Then
                Return True
            Else
                Return False
            End If
        End Function
#End Region

    End Class
End Namespace

