﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Data.Entity
Imports System.Text
Imports System.Threading
Imports System.Windows.Threading
Imports MahApps.Metro.Controls.Dialogs

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Transationen Repeat:

        Private WithEvents __transactions_repeat As New ObservableCollection(Of transactions_repeat_v01)
        Private WithEvents __trep2k As New ObservableCollection(Of transrep_2_kat)
        ''' <summary>
        ''' Alle Repeat Transaktionen
        ''' </summary>
        ''' <returns></returns>
        Public Property Transactions_Repeat As ListCollectionView
        Public Property Transactions_RepeatUpcoming() As ListCollectionView

        Private Sub TransactionsRepeatLoad()
            __transactions_repeat.Clear()
            __trep2k.Clear()

            dbo.m_transactions_repeat_v01.Load
            dbo.m_transrep_2_kat.Load
            __transactions_repeat = dbo.m_transactions_repeat_v01.Local
            __trep2k = dbo.m_transrep_2_kat.Local
            Transactions_Repeat = New ListCollectionView(__transactions_repeat)
            With Transactions_Repeat
                .LiveSortingProperties.Add("faelligkeit")
                .SortDescriptions.Add(New SortDescription("faelligkeit", ListSortDirection.Ascending))
                .IsLiveSorting = True
            End With

            Transactions_RepeatUpcoming = New ListCollectionView(__transactions_repeat) With {
                .Filter = New Predicate(Of Object)(AddressOf Filters.TransRepUpcoming)
            }
            Transactions_RepeatUpcoming.SortDescriptions.Add(New SortDescription("faelligkeit", ListSortDirection.Ascending))

            'necessary to avoid an bug which causes the duplicate and delete command to be switched of if just 1 item is available:
            TransRepSelectedItems = __transactions_repeat.ToList
            TransRepSelectedItems.Clear()
            TransRepSelectedItems.Add(__transactions_repeat.FirstOrDefault)

        End Sub

        Private Sub __transactions_repeat_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __transactions_repeat.CollectionChanged
            'If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not Transactions_Repeat Is Nothing Then
                If Not Transactions_Repeat.MoveCurrentToNext Then Transactions_Repeat.MoveCurrentToPrevious()
            End If
            If Not Transactions_RepeatUpcoming Is Nothing Then
                If Not Transactions_RepeatUpcoming.MoveCurrentToNext Then Transactions_RepeatUpcoming.MoveCurrentToPrevious()
                If Not Transactions_RepeatUpcoming.IsAddingNew Or Transactions_RepeatUpcoming.IsEditingItem Then
                    With Transactions_RepeatUpcoming
                        .Filter = Nothing
                        .Filter = New Predicate(Of Object)(AddressOf Filters.TransRepUpcoming)
                        .SortDescriptions.Clear()
                        .SortDescriptions.Add(New SortDescription("faelligkeit", ListSortDirection.Ascending))
                    End With
                End If
            End If
        End Sub

#Region "Commands"
        Public Property cmdTransactionRepeatAdd As New RelayCommand(Of Object())(Sub(p) TransactionRepeatAdd(p), Function(p) TransactionRepeatAddCanExecute(p))
        Public Property cmdTransactionRepeatEdit As New RelayCommand(Of transactions_repeat_v01)(Sub(p) TransactionRepeatEdit(p), Function(p) TransactionRepeatCanEdit(p))

        ''' <summary>
        ''' This command is necessary to receive the currently selected Repeat Transactions from the containing listview of the view
        ''' Command is necessary because datagrid selecteditems is not a dependency property see:
        ''' http://blog.galasoft.ch/posts/2010/05/handling-datagrid-selecteditems-in-an-mvvm-friendly-manner/
        ''' </summary>
        ''' <returns></returns>
        Public Property cmdTransactionRepeatSelectionChanged As New RelayCommand(Of IList)(Sub(p) TransactionRepeatSelectionChanged(p))
        ''' <summary>
        ''' Edits an Object of Type TransactionRepeat by using the current selected Item of the ListcollectionView (used by Ribbon Menu)
        ''' </summary>
        ''' <returns></returns>
        Public Property cmdTransactionRepeatEditIndirect As New RelayCommand(AddressOf TransactionRepeatEditIndirect, Function() Transactions_Repeat.Count > 0 AndAlso Transactions_Repeat.CurrentItem IsNot Nothing)
        Public Property cmdTransactionsRepeatDuplicate As New RelayCommand(AddressOf TransactionsRepeatDuplicate, Function() TransactionsRepeatCanDeleteDuplicate())
        'Deletes more than one Transaction at once
        Public Property cmdTransactionsRepeatDelete As New RelayCommand(AddressOf TransactionsRepeatDelete, Function() TransactionsRepeatCanDeleteDuplicate())
        Public Property cmdTransactionRepeatCatAdd As New RelayCommand(Of transactions_repeat_v01)(Sub(p) TransactionRepeatCatAdd(p), Function(p) p IsNot Nothing)
        Public Property cmdTransactionRepeatCatDelete As New RelayCommand(Of Object())(Sub(p) TransactionRepeatCatDelete(p), Function(p) TransactionRepeatCatCanDelete(p))
        Public Property cmdTransactionRepeatCatEdit As New RelayCommand(Of transrep_2_kat)(Sub(p) TransactionRepeatCatEdit(p), Function(p) p IsNot Nothing)
        Public Property cmdTransactionRepeatSaveChanges As New RelayCommand(Of transactions_repeat_v01)(Sub(p) TransactionRepeatSaveChanges(p), Function(p) TransactionRepeatCanSaveChanges(p))
        Public Property cmdTransactionRepeatExecute As New RelayCommand(AddressOf TransactionRepeatExecute, Function() Transactions_Repeat.Count > 0 AndAlso Transactions_Repeat.CurrentItem IsNot Nothing)


        Private Async Sub TransactionRepeatAdd(Optional v_obj As Object() = Nothing)
            Dim v_dia As New frm_transactionrepeat_addedit
            Dim v_newreptrans As New transactions_repeat_v01
            Dim v_typ As String = ""
            Dim v_konto As konto_v01 = Nothing
            If v_obj IsNot Nothing Then
                v_typ = v_obj(0).ToString
                v_konto = TryCast(v_obj(1), konto_v01)
            End If


            'Setting the presets:
            If Not v_newreptrans Is Nothing Then
                If v_typ = "" Then v_typ = "aus"
                Dim v_transtyp As New trans_typ_v01
                v_transtyp = __typen.Where(Function(x) x.internal_name = v_typ).First
                If v_newreptrans.transtyp_id = Nothing Then v_newreptrans.transtyp_id = v_transtyp.typ_id
                v_transtyp = Nothing
                If v_konto Is Nothing Then
                    If Konten_Aktiv.CurrentItem Is Nothing Then Konten_Aktiv.MoveCurrentToFirst()
                    v_newreptrans.konto_id = DirectCast(Konten_Aktiv.CurrentItem, konto_v01).kto_id
                Else
                    v_newreptrans.konto_id = v_konto.kto_id
                End If

                'Define Standards:
                With v_newreptrans
                    If preset_date <> Nothing Then .datum = preset_date
                    If SettingsCurrent.active_person Then
                        If preset_person_id <> Nothing Then .person_id = preset_person_id
                    End If
                    If SettingsCurrent.active_receiver Then
                        If preset_receiver_id <> Nothing Then .receiver_id = preset_receiver_id
                    End If
                    If SettingsCurrent.active_status Then
                        If preset_status_id <> Nothing Then .transstatus_id = preset_status_id
                    End If

                End With
            End If

            With v_dia
                .Title = "Wiederholungs-Buchung hinzufügen"
                .DataContext = v_newreptrans
                .ShowDialog()
                If .DialogResult Then

                    'check if a new status shell be added if status is used in database
                    If SettingsCurrent.active_status Then v_newreptrans.transstatus_id = Await check_status(.cmb_status.SelectedItem, .cmb_status.Text)
                    'check if a new person shell be added if person is used in database
                    If SettingsCurrent.active_person Then v_newreptrans.person_id = Await check_person(.cmb_person.SelectedItem, .cmb_person.Text)
                    'check if a new receiver shell be added if receiver is used in database
                    If SettingsCurrent.active_receiver Then v_newreptrans.receiver_id = Await check_receiver(.cmb_empf.SelectedItem, .cmb_empf.Text)

                    TransactionRepeatConsistencyCheck(v_newreptrans)

                    If transactionrepeat_consistency_checker(v_newreptrans) Then
                        Transactions_Repeat.AddNewItem(v_newreptrans)
                        Transactions_Repeat.CommitNew()
                        dbo.SaveChanges()
                        dbo.ChangeTracker.DetectChanges()
                        __transactions_repeat_CollectionChanged(Me, Nothing)
                    Else
                        cls_logger.v_logger.Error("WH Transaction Consistency Check failed")
                        Throw New System.Exception("Validierung der Wiederholungs-Transaktion fehlgeschlagen, um Fehler zu vermeiden wird das Programm beendet")
                    End If
                End If
            End With
        End Sub

        Private Function TransactionRepeatConsistencyCheck(v_trans As transactions_repeat_v01) As Boolean
            If v_trans Is Nothing Then Return False
            With v_trans
                If .transstatus_id Is Nothing Then .transstatus_id = __status.Where(Function(x) CBool(x.predefined) = True).FirstOrDefault.status_id
                If .person_id Is Nothing Then .person_id = __persons.Where(Function(x) CBool(x.predefined) = True).FirstOrDefault.pers_id
                If .receiver_id Is Nothing Then .receiver_id = __reveicer.Where(Function(x) CBool(x.predefined) = True).FirstOrDefault.rec_id
            End With
            Return True
        End Function

        Private Function TransactionRepeatAddCanExecute(v_obj As Object()) As Boolean
            'if no konto is present disable command:
            If Konten_Aktiv.Count = 0 Then Return False
            If v_obj Is Nothing Then Return False
            Dim v_typ As String = v_obj(0).ToString
            If v_typ = "" Then Return False
            Return True
        End Function

        Dim TransRepSelectedItems As IList(Of transactions_repeat_v01) = Nothing

        Private Sub TransactionRepeatSelectionChanged(v_selected_items As IList)
            If Not TransRepSelectedItems Is Nothing Then TransRepSelectedItems.Clear()
            TransRepSelectedItems = CType(v_selected_items, System.Collections.IList).Cast(Of transactions_repeat_v01).Cast(Of transactions_repeat_v01).ToList
        End Sub


        Private Async Sub TransactionRepeatEdit(v_trans As transactions_repeat_v01)
            If v_trans Is Nothing Then Exit Sub
            'Editieren einer WiederholungsTransaktion:
            Dim v_dia As New frm_transactionrepeat_addedit
            v_trans.BeginEdit()
            With v_dia
                .Title = "Wiederholungs Buchung bearbeiten"
                .DataContext = v_trans
                .ShowDialog()
                If .DialogResult Then

                    'check if a new status shell be added if status is used in database
                    If SettingsCurrent.active_status Then v_trans.transstatus_id = Await check_status(.cmb_status.SelectedItem, .cmb_status.Text)
                    'check if a new person shell be added if person is used in database
                    If SettingsCurrent.active_person Then v_trans.person_id = Await check_person(.cmb_person.SelectedItem, .cmb_person.Text)
                    'check if a new receiver shell be added if receiver is used in database
                    If SettingsCurrent.active_receiver Then v_trans.receiver_id = Await check_receiver(.cmb_empf.SelectedItem, .cmb_empf.Text)


                    TransactionRepeatConsistencyCheck(v_trans)

                    If transactionrepeat_consistency_checker(v_trans) Then
                        v_trans.EndEdit()
                        dbo.SaveChanges()
                        dbo.ChangeTracker.DetectChanges()
                        __transactions_repeat_CollectionChanged(Me, Nothing)
                    Else
                        cls_logger.v_logger.Error("WH Transaction Consistency Check failed")
                        Throw New System.Exception("Validierung der Wiederholungs-Transaktion fehlgeschlagen, um Fehler zu vermeiden wird das Programm beendet")
                    End If
                Else
                    v_trans.CancelEdit()
                End If
            End With
        End Sub


        Private Function TransactionRepeatCanEdit(v_trans As transactions_repeat_v01) As Boolean
            'if no konto is present disable command:
            If Konten_Aktiv.Count = 0 Then Return False
            If v_trans Is Nothing Then Return False
            Return True
        End Function

        Private Async Sub TransactionRepeatEditIndirect()
            Dim v_trans As transactions_repeat_v01 = CType(Transactions_Repeat.CurrentItem, transactions_repeat_v01)
            If v_trans Is Nothing Then Exit Sub
            'Editieren einer WiederholungsTransaktion:
            Dim v_dia As New frm_transactionrepeat_addedit
            v_trans.BeginEdit()
            With v_dia
                .Title = "wiederholungs Buchung bearbeiten"
                .DataContext = v_trans
                .ShowDialog()
                If .DialogResult Then

                    'check if a new status shell be added if status is used in database
                    If SettingsCurrent.active_status Then v_trans.transstatus_id = Await check_status(.cmb_status.SelectedItem, .cmb_status.Text)
                    'check if a new person shell be added if person is used in database
                    If SettingsCurrent.active_person Then v_trans.person_id = Await check_person(.cmb_person.SelectedItem, .cmb_person.Text)
                    'check if a new receiver shell be added if receiver is used in database
                    If SettingsCurrent.active_receiver Then v_trans.receiver_id = Await check_receiver(.cmb_empf.SelectedItem, .cmb_empf.Text)

                    If transactionrepeat_consistency_checker(v_trans) Then
                        v_trans.EndEdit()
                        dbo.SaveChanges()
                        dbo.ChangeTracker.DetectChanges()
                    Else
                        cls_logger.v_logger.Error("WH Transaction Consistency Check failed")
                        Throw New System.Exception("Validierung der Wiederholungs-Transaktion fehlgeschlagen, um Fehler zu vermeiden wird das Programm beendet")
                    End If
                Else
                    v_trans.CancelEdit()
                End If
            End With
        End Sub

        ''' <summary>
        ''' Duplicates the currently selected Repeat Transaction(s)
        ''' </summary>
        Private Async Sub TransactionsRepeatDuplicate()
            If TransRepSelectedItems Is Nothing Or TransRepSelectedItems.Count = 0 Then Exit Sub
            Dim v_question As String
            Dim v_header As String = "Wiederholungs-Buchung{0} duplizieren"
            If TransRepSelectedItems.Count = 1 Then
                v_question = "Wollen Sie die gewählte Wiederholungs-Buchung duplizieren?"
                v_header = String.Format(v_header, "")
            Else
                v_question = "Wollen Sie die gewählten {0} Wiederholungs-Buchungen duplizieren?"
                v_question = String.Format(v_question, TransRepSelectedItems.Count.ToString)
                v_header = String.Format(v_header, "en")
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = DirectCast(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync(v_header, v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                'Start the duplicate process
                'Because the duplication process changes the Selection of the Listview we have to transfer the IDs of the formerly selected items to a list:
                Dim v_selected_ids As New List(Of Integer)
                For Each item As transactions_repeat_v01 In TransRepSelectedItems
                    v_selected_ids.Add(item.trans_rep_id)
                Next
                For Each v_item_id As Integer In v_selected_ids
                    Dim v_quelle As transactions_repeat_v01 = dbo.m_transactions_repeat_v01.First(Function(x) x.trans_rep_id = v_item_id)
                    Dim v_duplicate As transactions_repeat_v01 = dbo.m_transactions_repeat_v01.AsNoTracking().First(Function(e) e.trans_rep_id = v_item_id)
                    dbo.m_transactions_repeat_v01.Add(v_duplicate)
                    'Save to db to get the new ID
                    dbo.SaveChanges()
                    'Transfer all categories:
                    For Each v_item As transrep_2_kat In v_quelle.categories_amount
                        Dim v_temp As transrep_2_kat = dbo.m_transrep_2_kat.AsNoTracking.First(Function(x) x.Id = v_item.Id)
                        If Not v_temp Is Nothing Then v_duplicate.categories_amount.Add(v_temp)
                    Next
                    'Tranfer all Tags:
                    For Each v_item As transrep_tag_v01 In v_quelle.tags
                        Dim v_temp As transrep_tag_v01 = dbo.m_transrep_tag_v01.AsNoTracking.First(Function(x) x.Id = v_item.Id)
                        If Not v_temp Is Nothing Then v_duplicate.tags.Add(v_temp)
                    Next
                    dbo.SaveChanges()
                    dbo.ChangeTracker.DetectChanges()

                Next
                Transactions_Repeat.MoveCurrentToLast()
            End If
        End Sub

        ''' <summary>
        ''' Checks if a Transaction doesn't provide konto and to_konto if not type is transfer
        ''' if the Transaction has a failure it will be repaired automatically
        ''' </summary>
        ''' <param name="v_transrep">TransactionRepeat to check</param>
        ''' <returns>Returns false if check fails</returns>
        Private Function transactionrepeat_consistency_checker(v_transrep As transactions_repeat_v01) As Boolean
            With v_transrep
                If v_transrep Is Nothing Then Return False
                'at this stage the nv_transtyp_trans_back property is empty in case the transaction is added new.
                'so check what item is represented bei transtyp_id

                Dim v_ctranstyp As trans_typ_v01 = __typen.First(Function(x) x.typ_id = .transtyp_id)

                If v_ctranstyp Is Nothing Then Return False

                If v_ctranstyp.multiplier = 0 Then
                    'Transfer:
                    'If transfer then set receiver_id to nothing because receiver of a transfer is another konto
                    If .receiver_id IsNot Nothing Then
                        .receiver_id = Nothing
                    End If
                Else
                    'not a transfer
                    If .to_konto_id IsNot Nothing Then
                        .to_konto_id = Nothing
                    End If
                End If
                Return True
            End With
        End Function

        Private Async Sub TransactionsRepeatDelete()
            If TransRepSelectedItems Is Nothing Or TransRepSelectedItems.Count = 0 Then Exit Sub
            Dim v_question As String
            Dim v_header As String = "Wiederholungs-Buchung{0} löschen"
            If TransRepSelectedItems.Count = 1 Then
                v_question = "Wollen Sie die gewählte Wiederholungs-Buchung löschen?"
                v_header = String.Format(v_header, "")
            Else
                v_question = "Wollen Sie die gewählten {0} Wiederholungs-Buchungen löschen?"
                v_question = String.Format(v_question, TransRepSelectedItems.Count.ToString)
                v_header = String.Format(v_header, "en")
            End If
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync(v_header, v_question, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                Debug.Print("v_transrep.count beforde: " & TransRepSelectedItems.Count.ToString)

                'Very stupid solution first creating a list of integer with all ids then searching with LINQ in the collection to remove ist...
                Dim v_idlist As New List(Of Integer)

                For i As Integer = 0 To TransRepSelectedItems.Count - 1
                    v_idlist.Add(CType(TransRepSelectedItems(i), transactions_repeat_v01).trans_rep_id)
                Next

                For i As Integer = 0 To v_idlist.Count - 1
                    Dim v_i As Integer = i
                    __transactions_repeat.Remove(__transactions_repeat.Where(Function(x) x.trans_rep_id = v_idlist(v_i)).First)
                Next
                dbo.SaveChanges()
            End If
        End Sub

        Private Function TransactionsRepeatCanDeleteDuplicate() As Boolean
            If TransRepSelectedItems Is Nothing OrElse TransRepSelectedItems.Count = 0 Then Return False
            If TransRepSelectedItems.Count = 1 Then
                If TransRepSelectedItems.FirstOrDefault Is Nothing Then Return False
            End If
            Return True
        End Function

#Region "Transaktion Repeat Kategorie"

        Private Sub TransactionRepeatCatAdd(v_trans As transactions_repeat_v01)
            Dim v_t2k As New transrep_2_kat
            Dim v_dia As New frm_transcat_addedit
            With v_dia
                .Title = "Eintrag hinzufügen"
                .DataContext = v_t2k
                .ShowDialog()
                If .DialogResult Then
                    'Add
                    v_trans.categories_amount.Add(v_t2k)
                    dbo.ChangeTracker.DetectChanges()
                Else
                    v_t2k = Nothing
                End If
            End With
        End Sub

        Private Async Sub TransactionRepeatCatDelete(v_obj As Object())
            If v_obj Is Nothing Then Exit Sub
            Dim v_transrep As transactions_repeat_v01 = DirectCast(v_obj(0), transactions_repeat_v01)
            Dim v_t2ks As IEnumerable(Of transrep_2_kat) = DirectCast(v_obj(1), IList).Cast(Of transrep_2_kat)
            Dim v_strbuilder As New StringBuilder
            v_strbuilder.AppendLine("Wollen Sie die folgenden Kategorien innerhalb der Wiederholungs-Buchung löschen?")
            For Each v_item As transrep_2_kat In v_t2ks
                'It's possible that the nv_cat_trans2kat_back property is nothing
                If v_item.category Is Nothing Then
                    v_strbuilder.AppendLine(getCatBezeichnungById(v_item.category_id))
                Else
                    v_strbuilder.AppendLine(v_item.category.bezeichnung)
                End If
            Next
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Eintrag löschen", v_strbuilder.ToString, MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                While v_t2ks.Count > 0
                    If __trep2k.Remove(v_t2ks.First) = False Then
                        'Category could not removed from observablecollection => happens if a newly created transaction tries to delete a newly created t2k
                        v_transrep.categories_amount.Remove(v_t2ks.First)
                    End If
                End While
                dbo.SaveChanges()
            End If
        End Sub

        Private Function TransactionRepeatCatCanDelete(v_obj As Object()) As Boolean
            If v_obj Is Nothing Then Return False
            If v_obj(0) Is Nothing Then Return False
            If v_obj(1) Is Nothing Then Return False
            Return True
        End Function

        Private Sub TransactionRepeatCatEdit(v_t2k As transrep_2_kat)
            If v_t2k Is Nothing Then Exit Sub
            Dim v_dia As New frm_transcat_addedit
            Dim v_trans_rep As transactions_repeat_v01 = v_t2k.transrep

            v_t2k.BeginEdit()

            With v_dia
                .Title = "Eintrag bearbeiten"
                .DataContext = v_t2k
                .ShowDialog()
                If .DialogResult Then
                    'Bearbeitung speichern
                    v_t2k.EndEdit()
                    dbo.SaveChanges()
                    dbo.ChangeTracker.DetectChanges()
                    v_trans_rep.Collection_CollectionChanged(Me, Nothing)
                Else
                    v_t2k.CancelEdit()
                    v_t2k = Nothing
                End If
            End With
        End Sub

        ''' <summary>
        ''' Saves Changes in a given TransactionsRepeat used mainly in ucl_transactionrepeat at DetailView
        ''' </summary>
        ''' <param name="v_trans"></param>
        Private Async Sub TransactionRepeatSaveChanges(v_trans As transactions_repeat_v01)
            If v_trans Is Nothing Then Exit Sub


            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await vMainWindow.ShowMessageAsync("Änderungen speichern", "Wollen Sie die Änderungen an der Wiederholungsbuchung speichern?", MessageDialogStyle.AffirmativeAndNegative, dia_settings)

            If result = MessageDialogResult.Affirmative Then
                If transactionrepeat_consistency_checker(v_trans) Then
                    v_trans.EndEdit()
                    dbo.SaveChanges()
                Else
                    v_trans.CancelEdit()
                End If
                v_trans.EndEdit()
            Else
                v_trans.CancelEdit()
            End If
        End Sub

        Private Function TransactionRepeatCanSaveChanges(v_trans As transactions_repeat_v01) As Boolean
            If v_trans Is Nothing Then Return False
            If v_trans.hasErrors Then Return False
            Return True
        End Function

#End Region

#End Region

#Region "Repeat Execution"
        ''' <summary>
        ''' Executes a Repeat Transaction manually => next Event Command
        ''' </summary>
        Private Async Sub TransactionRepeatExecute()
            Dim v_transrep As transactions_repeat_v01 = CType(Transactions_Repeat.CurrentItem, transactions_repeat_v01)
            If v_transrep Is Nothing Then Exit Sub
            Dim dia_settings = New MetroDialogSettings With {.AffirmativeButtonText = "Ja", .NegativeButtonText = "Nein"}
            Dim v_mainwindow As MainWindow = DirectCast(Application.Current.MainWindow, MainWindow)
            Dim result As MessageDialogResult = Await v_mainwindow.ShowMessageAsync("Manuelle Durchführung bestätigen", "Nächstes Event der selektierten Buchung durchführen?", MessageDialogStyle.AffirmativeAndNegative, dia_settings)
            If result <> MessageDialogResult.Affirmative Then Exit Sub
            If trans_rep_execute(v_transrep) Then
                Dim v_timeframe As cls_timeframe = __timeframes.First(Function(x) x.Id = v_transrep.rep_timeframe_id)
                v_transrep.faelligkeit = transrep_calc_bookingdate(v_timeframe, v_transrep.datum, v_transrep.faelligkeit, v_transrep.rep_timeframe_userdef)
                If Not Transactions_RepeatUpcoming.IsAddingNew Or Transactions_RepeatUpcoming.IsEditingItem Then Transactions_RepeatUpcoming.Filter = New Predicate(Of Object)(AddressOf Filters.TransRepUpcoming)
                Transactions_RepeatUpcoming.SortDescriptions.Add(New SortDescription("faelligkeit", ListSortDirection.Descending))
                dbo.SaveChanges()
                Await v_mainwindow.ShowMessageAsync("Buchung erfolgreich", "Nächtes Event der Wiederholungsbuchung erfolgreich durchgeführt")
            Else
                Await v_mainwindow.ShowMessageAsync("Buchung fehlgeschlagen", "Fehler bei der Durchführung des nächsten Events der Buchung")
            End If
        End Sub

        Private WithEvents v_prgmsg_transrep_execute As ProgressDialogController

        ''' <summary>
        ''' Executes repeats at init of the ViewModel
        ''' </summary>
        Public Async Sub Transactions_RepExecute()
            Dim v_count As Integer = 0
            Dim v_exe_count As Integer = 0
            'If no repeatable Transactions are available exit sub
            If Transactions_Repeat.Count = 0 Then Return

            Dim vMainWindow As MainWindow = CType(Application.Current.MainWindow, MainWindow)
            v_prgmsg_transrep_execute = Await vMainWindow.ShowProgressAsync("Wiederholungsbuchungen", "Buchungen werden jetzt durchgeführt", True, New MetroDialogSettings With {.NegativeButtonText = "Schließen"})
            v_prgmsg_transrep_execute.SetIndeterminate()
            Dim v_msgtext As New StringBuilder

            For Each v_transrep As transactions_repeat_v01 In Transactions_Repeat
                v_count += 1
                'Process:
                'Bookingdate (BD) <= Now()
                'if yes: calculate next booking date
                'if no continue for
                If v_transrep.faelligkeit = Nothing Or v_transrep.faelligkeit <= Date.Now Then
                    'Buchung Fällig
                    Dim v_timeframe As cls_timeframe = __timeframes.FirstOrDefault(Function(x) x.Id = v_transrep.rep_timeframe_id)
                    If v_timeframe Is Nothing Then
                        'Timeframe fehlerhaft
                        MessageAdd(New message_v01("Wiederholungsbuchung Fehler", "Zeitspanne der Wiederholungsbuchung konnte nicht ermittelt werden", True, 1, 1, True))
                        v_msgtext.AppendLine("Zeitspanne der Wiederholungsbuchung konnte nicht ermittelt werden")
                        v_prgmsg_transrep_execute.SetMessage(v_msgtext.ToString)
                        cls_logger.v_logger.Error("Timespan of TransRep is nothing occured in object booking id: " & v_transrep.trans_rep_id.ToString)
                        Continue For 'try next booking
                    End If
                    If v_transrep.faelligkeit = Nothing Then v_transrep.faelligkeit = v_transrep.datum 'Replace to keep for loop functional
                    While v_transrep.faelligkeit <= Date.Now
                        'Book as long as "Fälligkeitsdatum" is smaller then today.
                        'Check how often booking shall be done.
                        If v_transrep.rep_count_infinite Then
                            'infinite booking
                            trans_rep_execute(v_transrep)
                            'Calculate new date
                            v_transrep.faelligkeit = transrep_calc_bookingdate(v_timeframe, v_transrep.datum, v_transrep.faelligkeit, v_transrep.rep_timeframe_userdef)
                            v_msgtext.AppendLine("Buchung durchgeführt")
                            v_prgmsg_transrep_execute.SetMessage(v_msgtext.ToString)
                            v_exe_count += 1
                        Else
                            If v_transrep.rep_act_count < v_transrep.rep_max_count Then
                                trans_rep_execute(v_transrep)
                                'Calculate new date
                                v_transrep.faelligkeit = transrep_calc_bookingdate(v_timeframe, v_transrep.datum, v_transrep.faelligkeit, v_transrep.rep_timeframe_userdef)
                                v_transrep.rep_act_count += 1
                                v_msgtext.AppendLine("Buchung durchgeführt")
                                v_prgmsg_transrep_execute.SetMessage(v_msgtext.ToString)
                                v_exe_count += 1
                            Else
                                Exit While
                            End If
                        End If

                    End While
                    dbo.SaveChanges()
                End If
            Next
            v_msgtext.AppendLine(String.Format("Alle Buchungen überprüft, es wurden {0} Buchungen geprüft und {1} durchgeführt", v_count, v_exe_count))
            v_prgmsg_transrep_execute.SetMessage(v_msgtext.ToString)
            v_msgtext = Nothing
            MessageAdd(New message_v01("Wiederholungsbuchungen", String.Format("Es wurden {0} Buchungen geprüft und {1} durchgeführt", v_count, v_exe_count), False))
            If Not Transactions_RepeatUpcoming.IsAddingNew Or Transactions_RepeatUpcoming.IsEditingItem Then Transactions_RepeatUpcoming.Filter = New Predicate(Of Object)(AddressOf Filters.TransRepUpcoming)
            Transactions_RepeatUpcoming.SortDescriptions.Add(New SortDescription("faelligkeit", ListSortDirection.Descending))
            'Hide Window if no transaction was executed:
            If v_exe_count = 0 Then Await v_prgmsg_transrep_execute.CloseAsync()
        End Sub

        ''' <summary>
        ''' Calculates the next booking date
        ''' </summary>
        ''' <param name="_timeframe">Timeframe of the transaction</param>
        ''' <param name="_startdate">Startdate of transaction</param>
        ''' <param name="_lastdate">Last booking date</param>
        ''' <param name="_timeframeuser">Optional: user defined timespane</param>
        ''' <returns></returns>
        Private Function transrep_calc_bookingdate(_timeframe As cls_timeframe, _startdate As Date, _lastdate As Date, Optional _timeframeuser As Integer = Nothing) As Date
            If _timeframe Is Nothing Then Return Nothing
            If _startdate = Nothing Then Return Nothing
            Dim v_counter As Integer = Nothing
            If _timeframe.userdef_count Then
                v_counter = _timeframeuser
            Else
                v_counter = _timeframe.count
            End If

            Dim v_nextdate As New Date

            Select Case _timeframe.scope
                Case "D"
                    'Fokus daily
                    v_nextdate = _lastdate.AddDays(v_counter)
                Case "M"
                    'Fokus monthly
                    v_nextdate = _lastdate.AddMonths(v_counter)
                Case "Y"
                    'Fokus yearly
                    v_nextdate = _lastdate.AddYears(v_counter)
            End Select
            Return v_nextdate
        End Function

        Private Function trans_rep_execute(_transrep As transactions_repeat_v01) As Boolean
            If _transrep Is Nothing Then Return False
            'Create a new transaction
            Dim v_newtrans As New transactions_v01(_transrep)

            'Update the totalamount:
            v_newtrans.TotAmountCalc()
            v_newtrans.NotifyPropertyChanged("tags_str")
            Transactions.AddNewItem(v_newtrans)
            Transactions.CommitNew()
            dbo.SaveChanges()
            'update the totalamount of the account:
            If Not v_newtrans.nv_kto_2_trans_back Is Nothing Then v_newtrans.nv_kto_2_trans_back.Totalamount_Calculate()
            If Not v_newtrans.nv_kto_2_trans_transfer_back Is Nothing Then v_newtrans.nv_kto_2_trans_transfer_back.Totalamount_Calculate()
            dbo.SaveChanges()
            Transactions.MoveCurrentToLast()
            Return True
        End Function

        Private Async Sub v_prgmsg_transrep_execute_Canceled(sender As Object, e As EventArgs) Handles v_prgmsg_transrep_execute.Canceled
            Await v_prgmsg_transrep_execute.CloseAsync
        End Sub

#End Region


    End Class
End Namespace